<?php
$genMsg = "";

if (isset($_POST['refund'])) {
    if (!empty($_POST['transaction_id'])) {
        $transactionId = filter_string($_POST['transaction_id']);

        $sql = $link->prepare("SELECT * FROM transactions WHERE id = ?");
        $sql->bind_param("i", $transactionId);
        $sql->execute();
        $result = $sql->get_result();
        $row = $result->fetch_assoc();

        $amount = $row['amountcharged'];
        $username = $row['username'];
        $status = $row['status'];
        $reference = $row['ownreference'];

        $sql = $link->prepare("SELECT * FROM users WHERE username = ?");
        $sql->bind_param("s", $username);
        $sql->execute();
        $result = $sql->get_result();
        $row = $result->fetch_assoc();
        $email = $row['email'];
        $funds = $row['funds'];

        if ($status == "failed" || $status == "error" || $status == "refund") {
            $status = "error";
            $message = "Cannot perform refund on a successful transaction.";
            $genMsg = sendResponse($status, $message);
        } else {
            // Refund the user
            $sql = $link->prepare("UPDATE users SET funds = funds + ? WHERE username = ?");
            $sql->bind_param("ds", $amount, $username);
            $sql->execute();

            // Update the transaction status
            $sql = $link->prepare("UPDATE transactions SET status = 'refund' WHERE id = ?");
            $sql->bind_param("i", $transactionId);
            $sql->execute();

            // Record the transaction in the fundwallet database
            $balanceBefore = $funds;
            $balanceAfter = $balanceBefore + $amount;

            $sql = $link->prepare("INSERT INTO fundwallet (username, status, message, balancebefore, balanceafter, amount, initiatedfrom, trxid, date, channel) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
            $status = "refund";
            $message = "Transaction refunded";
            $gateWay = "Transaction";
            $paymentMethod = "Transaction Refund";
            $sql->bind_param("ssssssssss", $username, $status, $message, $balanceBefore, $balanceAfter, $amount, $paymentMethod, $reference, $dateTime, $gateWay);
            if ($sql->execute()) {
                $status = "success";
                $message = "Transaction refunded";
                $genMsg = sendResponse($status, $message);
            } else {
                $status = "error";
                $message = "Something went wrong";
                $genMsg = sendResponse($status, $message);
            }
        }
    }
}

if (isset($_POST['mark_successful'])) {
    if (!empty($_POST['transaction_id'])) {
        $transactionId = filter_string($_POST['transaction_id']);

        $sql = $link->prepare("SELECT * FROM transactions WHERE id = ?");
        $sql->bind_param("i", $transactionId);
        $sql->execute();
        $result = $sql->get_result();
        $row = $result->fetch_assoc();

        $amount = $row['amountcharged'];
        $username = $row['username'];
        $status = $row['status'];
        $reference = $row['ownreference'];

        $sql = $link->prepare("SELECT * FROM users WHERE username = ?");
        $sql->bind_param("s", $username);
        $sql->execute();
        $result = $sql->get_result();
        $row = $result->fetch_assoc();
        $email = $row['email'];
        $funds = $row['funds'];

        if ($status == "success" || $status == "successful") {
            $status = "error";
            $message = "Transaction is already successful.";
            $genMsg = sendResponse($status, $message);
        } else {
            // Debit the user
            $sql = $link->prepare("UPDATE users SET funds = funds - ? WHERE username = ?");
            $sql->bind_param("ds", $amount, $username);
            $sql->execute();

            // Update the transaction status
            $sql = $link->prepare("UPDATE transactions SET status = 'success' WHERE id = ?");
            $sql->bind_param("i", $transactionId);
            $sql->execute();

            // Record the transaction in the fundwallet database
            $balanceBefore = $funds;
            $balanceAfter = $balanceBefore - $amount;

            $sql = $link->prepare("INSERT INTO fundwallet (username, status, message, balancebefore, balanceafter, amount, initiatedfrom, trxid, date, channel) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
            $status = "success";
            $message = "Transaction marked as successful";
            $gateWay = "Transaction";
            $paymentMethod = "Transaction Successful";
            $sql->bind_param("ssssssssss", $username, $status, $message, $balanceBefore, $balanceAfter, $amount, $paymentMethod, $reference, $dateTime, $gateWay);
            if ($sql->execute()) {
                $status = "success";
                $message = "Transaction marked as successful";
                $genMsg = sendResponse($status, $message);
            } else {
                $status = "error";
                $message = "Something went wrong";
                $genMsg = sendResponse($status, $message);
            }
        }
    }
}
?>
