<?php
$genMsg="";

if(isset($_POST['makeVendor'])){
    if(empty($_POST['username'])){
        $status="error";
        $message="Something went wrong"; 
        $genMsg=sendResponse($status, $message);
    }
    else{
        $username=filter_string($_POST['username']);
        $sql=$link->prepare("UPDATE users SET role='reseller' WHERE username=?");
        $sql->bind_param("s", $username);
        if($sql->execute()){
            $status="success";
            $message="$username changed to reseller"; 
            $genMsg=sendResponse($status, $message);
        }
        else{
            $status="error";
            $message="Something went wrong"; 
            $genMsg=sendResponse($status, $message);
        }
    }
}

if(isset($_POST['makeAdmin'])){
    if(empty($_POST['username'])){
        $status="error";
        $message="Something went wrong"; 
        $genMsg=sendResponse($status, $message);
    }
    else{
        $username=filter_string($_POST['username']);
        $sql=$link->prepare("UPDATE users SET role='admin' WHERE username=?");
        $sql->bind_param("s", $username);
        if($sql->execute()){
            $status="success";
            $message="$username changed to Admin"; 
            $genMsg=sendResponse($status, $message);
        }
        else{
            $status="error";
            $message="Something went wrong"; 
            $genMsg=sendResponse($status, $message);
        }
    }
}

if(isset($_POST['removeVendor'])){
    if(empty($_POST['username'])){
        $status="error";
        $message="Something went wrong"; 
        $genMsg=sendResponse($status, $message);
    }
    else{
        $username=filter_string($_POST['username']);
        $sql=$link->prepare("UPDATE users SET role='user' WHERE username=?");
        $sql->bind_param("s", $username);
        if($sql->execute()){
            $status="success";
            $message="$username removed as Reseller "; 
            $genMsg=sendResponse($status, $message);
        }
        else{
            $status="error";
            $message="Something went wrong"; 
            $genMsg=sendResponse($status, $message);
        }
    }
}

if(isset($_POST['suspendUser'])){
    if(empty($_POST['username'])){
        $status="error";
        $message="Something went wrong"; 
        $genMsg=sendResponse($status, $message);
    }
    else{
        $username=filter_string($_POST['username']);
        $sql=$link->prepare("UPDATE users SET status='suspended' WHERE username=?");
        $sql->bind_param("s", $username);
        if($sql->execute()){
            $status="success";
            $message="User <b>$username</b> has been suspended"; 
            $genMsg=sendResponse($status, $message);
        }
        else{
            $status="error";
            $message="Something went wrong"; 
            $genMsg=sendResponse($status, $message);
        }
    }
}

if(isset($_POST['deleteUser'])){
    if(empty($_POST['username'])){
        $status="error";
        $message="Something went wrong"; 
        $genMsg=sendResponse($status, $message);
    }
    else{
        $username=filter_string($_POST['username']);
        $sql=$link->prepare("DELETE FROM users WHERE username=?");
        $sql->bind_param("s", $username);
        if($sql->execute()){
            $status="success";
            $message="User <b>$username</b> has been deleted"; 
            $genMsg=sendResponse($status, $message);
        }
        else{
            $status="error";
            $message="Something went wrong"; 
            $genMsg=sendResponse($status, $message);
        }
    }
}



if(isset($_POST['activate'])){
    if(empty($_POST['username'])){
        $status="error";
        $message="Something went wrong"; 
        $genMsg=sendResponse($status, $message);
    }
    else{
        $username=filter_string($_POST['username']);
        $sql=$link->prepare("UPDATE users SET status='active' WHERE username=?");
        $sql->bind_param("s", $username);
        if($sql->execute()){
            $status="success";
            $message="User activated"; 
            $genMsg=sendResponse($status, $message);
        }
        else{
            $status="error";
            $message="Something went wrong"; 
            $genMsg=sendResponse($status, $message);
        }
    }
}

if(isset($_POST['sendCoupon'])){
    if(empty($_POST['username'])){
        $status="error";
        $message="Something went wrong"; 
        $genMsg=sendResponse($status, $message);
    }
    else{
        $username=filter_string($_POST['username']);
        $coupon=strtoupper(get_rand_alphanumeric(12));
        $sql=$link->prepare("INSERT INTO coupons(coupon,vendor,date) VALUES(?,?,?)");
        $sql->bind_param("sss", $coupon, $username, $dateTime);
        if($sql->execute()){
            $status="success";
            $message="Coupon sent to $username coupon: <strong>$coupon</strong>"; 
            $genMsg=sendResponse($status, $message);
        }
        else{
            $status="error";
            $message="Something went wrong"; 
            $genMsg=sendResponse($status, $message);
        }
    }
}


if(isset($_POST['deleteCoupon'])){
    if(empty($_POST['id'])){
        $status="error";
        $message="Something went wrong"; 
        $genMsg=sendResponse($status, $message);
    }
    else{
        $id=filter_string($_POST['id']);
        $sql=$link->prepare("DELETE FROM coupons WHERE id=?");
        $sql->bind_param("s", $id);
        if($sql->execute()){
            $status="success";
            $message="Code deleted"; 
            $genMsg=sendResponse($status, $message);
        }
        else{
            $status="error";
            $message="Something went wrong"; 
            $genMsg=sendResponse($status, $message);
        }
    }
}

if(isset($_POST['generateCoupon'])){
    if(empty($_POST['vendor'])){
        $status="error";
        $message="Select a vendor"; 
        $genMsg=sendResponse($status, $message);
    }
    else if(empty($_POST['couponNum'])){
        $status="error";
        $message="Enter coupon quantity"; 
        $genMsg=sendResponse($status, $message);
    }
    else if(!is_numeric($_POST['couponNum'])){
        $status="error";
        $message="Enter a valid coupon number"; 
        $genMsg=sendResponse($status, $message);
    }
    else if($_POST['couponNum'] < 0){
        $status="error";
        $message="Coupon quantity must be greater than 0"; 
        $genMsg=sendResponse($status, $message);
    }
    else{
        $vendor=filter_string($_POST['vendor']);
        $couponNum=filter_string($_POST['couponNum']);
        $coupons="";
        for($i=1; $i <= $couponNum; $i++){
            $coupon=strtoupper(get_rand_alphanumeric(12));
            $sql=$link->prepare("INSERT INTO coupons(coupon,vendor,date) VALUES(?,?,?)");
            $sql->bind_param("sss", $coupon, $vendor, $dateTime);
            $sql->execute();
            $coupons.="$coupon <br>";
        }
        $status="success";
        $message="Coupons generate. Coupons:<br><strong>$coupons</strong>"; 
        $genMsg=sendResponse($status, $message);
    }
}

if(isset($_POST['fundUser'])){
    if(empty($_POST['username'])){
        $status="error";
        $message="Enter username"; 
        $genMsg=sendResponse($status, $message);
    }
    else if(empty($_POST['amount'])){
        $status="error";
        $message="Enter amount"; 
        $genMsg=sendResponse($status, $message);
    }
    else{
        $username=filter_string($_POST['username']);
        $sql=$link->prepare("SELECT * FROM users WHERE username=?");
        $sql->bind_param("s", $username);
        $sql->execute();
        $result=$sql->get_result();
        $numrow=$result->num_rows;
        $row=$result->fetch_assoc();
        $email=$row['email'];
        $balBefore=$row['funds'];
        if($numrow == 1){
            $dataAmount=filter_string($_POST['amount']);
            $transactionid=$reference=get_rand_alphanumeric(20) ;
            $paymentMethod="Admin";
            $status="success";
            $gateWay="Admin Funding";
            $message="Funding successful";
            $sql=$link->prepare("UPDATE users SET funds=funds + ? WHERE username=?");
            $sql->bind_param("ss", $dataAmount, $username);
            if($sql->execute()){
                $sql=$link->prepare("SELECT * FROM users WHERE username=?");
                $sql->bind_param("s", $username);
                $sql->execute();
                $result=$sql->get_result();
                $numrow=$result->num_rows;
                $row=$result->fetch_assoc();
                $balAfter=$row['funds'];        
                $sql=$link->prepare("INSERT INTO fundwallet(code, username, email, amount, channel, status, trxid, initiatedfrom, balancebefore, balanceafter, date, message, currency) VALUES(?,?,?,?,?,?,?,?,?,?,?,?,?)") ;
        		$sql->bind_param("sssssssssssss", $reference, $username, $email, $dataAmount, $paymentMethod, $status, $transactionid, $gateWay, $balBefore, $balAfter, $dateTime, $message, $naira) ;
        		if($sql->execute()){
        		    $status="success";
                    $message="$dataAmount sent to $username"; 
                    $genMsg=sendResponse($status, $message);
        		}
        		else{
                    $status="error";
                    $message="Something went wrong 01"; 
                    $genMsg=sendResponse($status, $message);
                }
            }
            else{
                $status="error";
                $message="Something went wrong 02"; 
                $genMsg=sendResponse($status, $message);
            }
        }
        else{
            $status="error";
            $message="User not found"; 
            $genMsg=sendResponse($status, $message);
        }
    }
}

if(isset($_POST['debitUser'])){
    if(empty($_POST['username'])){
        $status="error";
        $message="Enter username"; 
        $genMsg=sendResponse($status, $message);
    }
    else if(empty($_POST['amount'])){
        $status="error";
        $message="Enter amount"; 
        $genMsg=sendResponse($status, $message);
    }
    else{
        $username=filter_string($_POST['username']);
        $sql=$link->prepare("SELECT * FROM users WHERE username=?");
        $sql->bind_param("s", $username);
        $sql->execute();
        $result=$sql->get_result();
        $numrow=$result->num_rows;
        $row=$result->fetch_assoc();
        $email=$row['email'];
        $balBefore=$row['funds'];
        if($numrow == 1){
            $dataAmount=filter_string($_POST['amount']);
            $transactionid=$reference=get_rand_alphanumeric(20) ;
            $paymentMethod="Admin";
            $status="success";
            $gateWay="Admin Debit";
            $message="Debit successful";
            $sql=$link->prepare("UPDATE users SET funds=funds - ? WHERE username=?");
            $sql->bind_param("ss", $dataAmount, $username);
            if($sql->execute()){
                $sql=$link->prepare("SELECT * FROM users WHERE username=?");
                $sql->bind_param("s", $username);
                $sql->execute();
                $result=$sql->get_result();
                $numrow=$result->num_rows;
                $row=$result->fetch_assoc();
                $balAfter=$row['funds'];  
                $sql=$link->prepare("INSERT INTO fundwallet(code, username, email, amount, channel, status, trxid, initiatedfrom, balancebefore, balanceafter, date, message, currency) VALUES(?,?,?,?,?,?,?,?,?,?,?,?,?)") ;
        		$sql->bind_param("sssssssssssss", $reference, $username, $email, $dataAmount, $paymentMethod, $status, $transactionid, $gateWay, $balBefore, $balAfter, $dateTime, $message, $naira) ;
        		if($sql->execute()){
        		    $status="success";
                    $message="$dataAmount debited from $username"; 
                    $genMsg=sendResponse($status, $message);
        		}
        		else{
                    $status="error";
                    $message="Something went wrong 01"; 
                    $genMsg=sendResponse($status, $message);
                }
            }
            else{
                $status="error";
                $message="Something went wrong 02"; 
                $genMsg=sendResponse($status, $message);
            }
        }
        else{
            $status="error";
            $message="User not found"; 
            $genMsg=sendResponse($status, $message);
        }
    }
}


if(isset($_POST['createUser'])){
    if(empty($_POST['username'])){
        $status="error";
        $message="Enter username"; 
        $genMsg=sendResponse($status, $message);
    }
    else if(empty($_POST['email'])){
        $status="error";
        $message="Enter email"; 
        $genMsg=sendResponse($status, $message);
    }
    else if(empty($_POST['fullname'])){
        $status="error";
        $message="Enter fullname"; 
        $genMsg=sendResponse($status, $message);
    }
    else if(empty($_POST['phone'])){
        $status="error";
        $message="Enter phone"; 
        $genMsg=sendResponse($status, $message);
    }
    else if(strlen($_POST['phone']) != 11){
        $status="error";
        $message="Invalid phone number";
        $genMsg=sendResponse($status, $message);
    }
    else if(empty($_POST['password'])){
        $status="error";
        $message="Enter a password";
        $genMsg=sendResponse($status, $message);
    }
    else if(strlen($_POST['password']) < 8){
        $status="error";
        $message="Password must be at least 8 characters";
        $genMsg=sendResponse($status, $message);
    }
    else{
        $fullnameC=filter_string($_POST['fullname']);
        $usernameC=filter_string($_POST['username']);
        $emailC=filter_string($_POST['email']);
        $phoneC=filter_string($_POST['phone']);
        $passwordC=filter_string($_POST['password']);
        
        $sql=$link->prepare("SELECT * FROM users WHERE username=?");
        $sql->bind_param("s", $usernameC);
        $sql->execute();
        $result=$sql->get_result();
        $numrow_user=$result->num_rows;

        $sql=$link->prepare("SELECT * FROM users WHERE email=?");
        $sql->bind_param("s", $emailC);
        $sql->execute();
        $result=$sql->get_result();
        $numrow_email=$result->num_rows;

        $sql=$link->prepare("SELECT * FROM users WHERE phone=?");
        $sql->bind_param("s", $phoneC);
        $sql->execute();
        $result=$sql->get_result();
        $numrow_phone=$result->num_rows;

        if($numrow_user > 0){
            $status="error";
            $message="Username already exist";
            $genMsg=sendResponse($status, $message);
        }
        else if($numrow_email > 0){
            $status="error";
            $message="Email already exist";
            $genMsg=sendResponse($status, $message);
        }
        else if($numrow_phone > 0){
            $status="error";
            $message="Phone number already in use";
            $genMsg=sendResponse($status, $message);
        }
        else{
            $passwordC=sha1($passwordC);
            $passwordC=password_hash($passwordC, PASSWORD_DEFAULT);
            
            $sql=$link->prepare("INSERT INTO users(fullname, username, email, phone, password, date, time) VALUES(?,?,?,?,?,?,?)");
            $sql->bind_param("sssssss", $fullnameC, $usernameC, $emailC, $phoneC, $passwordC, $dateTime, $time);
            if($sql->execute()){
                $status="success";
                $message=" $usernameC added as User";
                $genMsg=sendResponse($status, $message);
            }
            else{
                $status="error";
                $message="Something went wrong creating user";
                $genMsg=sendResponse($status, $message);
            }
        }
    }
}

?>