<?php 
require $_SERVER['DOCUMENT_ROOT']."/stream.php";
require $_SERVER['DOCUMENT_ROOT']."$stream/includes/generalinclude.php";
require $_SERVER['DOCUMENT_ROOT']."$stream/admin/includes/generalinclude.php";
require $_SERVER['DOCUMENT_ROOT']."$stream/admin/actions/history.php";

include "inc/header.php";
?>

<div class="container-fluid px-2">
    <div class="layout-specing">
        <div class="d-md-flex justify-content-between align-items-center">
            <h5 class="mb-0">Transactions History</h5>
            <nav aria-label="breadcrumb" class="d-inline-block mt-2 mt-sm-0">
                <ul class="breadcrumb bg-transparent rounded mb-0 p-0">
                    <li class="breadcrumb-item text-capitalize"><a href=""></a></li>
                    <li class="breadcrumb-item text-capitalize active" aria-current="page">Transactions History</li>
                </ul>
            </nav>
        </div>
        <div class="row">
            <div class="col mt-4 pt-2" id="tables">
                <div class="component-wrapper rounded shadow">
                    <div class="p-4 border-bottom">
                        <h4 class="title mb-0"> All </h4>
                    </div>
                    <?php echo $genMsg?>
                    <div class="">
                        <div class="table-responsive bg-white shadow rounded">
                            <table class="table mb-0 table-center" id="myTable" data-order='[[0, 1, "desc"]]'>
                                <thead>
                                    <tr>
                                        <th>ID</th>
                                        <th>Username</th>
                                        <th>Amount</th>
                                        <th>Amount Charged</th>
                                        <th>Bal Before</th>
                                        <th>Bal After</th>
                                        <th>Type</th>
                                        <th>Service</th>
                                        <th>Number</th>
                                        <th>Message</th>
                                        <th>Reference</th>
                                        <th>Date</th>
                                        <th>Status</th>
                                        <th>Channel</th>
                                        <th>Action</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <?php 
                                    $sql = $link->prepare("SELECT * FROM transactions ORDER BY id DESC LIMIT 500");
                                    $sql->execute();
                                    $result = $sql->get_result();
                                    $numrow = $result->num_rows;
                                    if ($numrow > 0) {
                                        while ($row = $result->fetch_assoc()) {
                                            $id = $row['id'];
                                            $type = $row['type'];
                                            $desc = $row['description'];
                                            $amount = $row['amount'];
                                            $amountcharged = $row['amountcharged'];
                                            $date = $row['date'];
                                            $status = $row['status'];
                                            $username = $row['username'];
                                            $balberfore = $row['balbefore'];
                                            $balafter = $row['balafter'];
                                            $message = $row['message'];
                                            $number = $row['number'];
                                            $reference = $row['ownreference'];                                        
                                            $statusColor = ($status == "success" || $status == "successful") ? "success" : "danger";
                                            $channel = $row['channel'];
                                    ?>
                                            <tr>
                                                <td><?php echo $id ?></td>
                                                <td><?php echo $username ?></td>
                                                <td>₦<?php echo number_format((int)$amount, 2) ?></td>
                                                <td>₦<?php echo number_format((int)$amountcharged, 2) ?></td>
                                                <td>₦<?php echo number_format((int)$balberfore, 2) ?></td>
                                                <td>₦<?php echo number_format((int)$balafter, 2) ?></td>
                                                <td><?php echo $type ?></td>
                                                <td><?php echo $desc ?></td>
                                                <td><?php echo $number ?></td>
                                                <td><?php echo $message ?></td>
                                                <td><?php echo $reference ?></td>
                                                <td><?php echo $date ?></td>
                                                <td class="text-center p-3">
                                                    <div class="badge bg-soft-<?php echo $statusColor ?> rounded px-3 py-1">
                                                        <?php echo $status ?>
                                                    </div>
                                                </td>
                                                <td><?php echo $channel ?></td>
                                                <td class="text-center">
                                                    <?php if ($status != "success" && $status != "successful") { ?>
                                                        <form method="POST" class="d-inline-block">
                                                            <input type="hidden" name="transaction_id" value="<?php echo $id ?>">
                                                            <button type="submit" name="mark_successful" class="btn btn-success btn-sm">Mark Successful</button>
                                                        </form>
                                                    <?php } else { ?>
                                                        <form method="POST" class="d-inline-block">
                                                            <input type="hidden" name="transaction_id" value="<?php echo $id ?>">
                                                            <button type="submit" name="refund" class="btn btn-primary btn-sm">Refund</button>
                                                        </form>
                                                    <?php } ?>
                                                </td>
                                            </tr>
                                    <?php
                                        }
                                    } else {
                                        ?>
                                        <tr>
                                            <td colspan="12" class="text-center">No transactions found.</td>
                                        </tr>
                                    <?php } ?>
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div><!--end col-->
        </div>
    </div>
</div><!--end container-->
<?php include "inc/footer.php" ?>