<?php

function apiBalance2() {
    global $ncWalletUsername, $ncWalletPassword, $ncWalletApiKey ;
    $curl = curl_init(); 
    curl_setopt_array($curl, array( 
        CURLOPT_URL => 'https://ncwallet.ng/api/user/details', 
        CURLOPT_RETURNTRANSFER => true, 
        CURLOPT_ENCODING => '', 
        CURLOPT_MAXREDIRS => 10, 
        CURLOPT_TIMEOUT => 0, 
        CURLOPT_FOLLOWLOCATION => true, 
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1, 
        CURLOPT_CUSTOMREQUEST => 'GET', 
        CURLOPT_HTTPHEADER => array( 
            'Content-Type: application/json', 
            'Authorization: Basic '.$ncWalletApiKey,
        ), 
    )); 
    $response = curl_exec($curl); 
    curl_close($curl); 

    $data = json_decode($response, true); 
    if ($data['status'] == 'success') {
        $balance = str_replace(',', '', $data['balance']);
        $balance = floatval($balance);
        return $balance;
    } else {
        //throw new Exception('API Error: '.$response);
        $balance=0;
    }
}

function apiBalance3() {
    global $gladTidingsApiKey;
    $curl = curl_init();
    curl_setopt_array($curl, array(
        CURLOPT_URL => 'https://www.gladtidingsdata.com/api/user/',
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => '',
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 0,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => 'POST',
        CURLOPT_HTTPHEADER => array(
            'Content-Type: application/json',
            'Authorization: Token ' . $gladTidingsApiKey,
        ),
    ));
    $response = curl_exec($curl);
    curl_close($curl);

    $data = json_decode($response, true);
    if (isset($data['user']['wallet_balance'])) {
        $balance = str_replace(',', '', $data['user']['wallet_balance']);
        $balance = floatval($balance);
        return $balance;
    } else {
        //throw new Exception('API Error: '.$response);
        $balance=0;
    }
}

function apiBalance4() {
    global $uzobestApiKey;
    $curl = curl_init();
    curl_setopt_array($curl, array(
        CURLOPT_URL => 'https://www.uzobestgsm.ng/api/v1/user_balance',
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => '',
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 0,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => 'GET',
        CURLOPT_HTTPHEADER => array(
            'Authorization: '.$uzobestApiKey,
        ),
    ));
    $response = curl_exec($curl);
	$response=json_decode($response, true) ;
    curl_close($curl);


    $status=$response['status'];
    $funds=0;
    if($status == "successful"){
        $funds=$response['balance'];
    }
    return $funds;
}


function apiBalance5(){
	global $inlomaxApiKey ;
	$curl = curl_init();
	curl_setopt_array($curl, array(
	  CURLOPT_URL => "https://inlomax.com/api/balance.php",
	  CURLOPT_RETURNTRANSFER => true,
	  CURLOPT_ENCODING => "",
	  CURLOPT_MAXREDIRS => 10,
	  CURLOPT_TIMEOUT => 0,
	  CURLOPT_FOLLOWLOCATION => true,
	  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
	  CURLOPT_CUSTOMREQUEST => "GET",
	  CURLOPT_HTTPHEADER => array(
        "cache-control: no-cache",
		"Content-Type: application/json",
		"Authorization: Token $inlomaxApiKey", 
	  ),
	));
	     
	$response = curl_exec($curl);
	$response=json_decode($response, true) ;
    curl_close($curl);


    $status=$response['status'];
    $funds=0;
    if($status == "success"){
        $funds=$response['data']['funds'];
    }
    return $funds;
}

function apiBalance6(){
	global $gwanyoApiKey ;
	$curl = curl_init();
	curl_setopt_array($curl, array(
	  CURLOPT_URL => "https://gwanyoconnect.com.ng/api/balance.php",
	  CURLOPT_RETURNTRANSFER => true,
	  CURLOPT_ENCODING => "",
	  CURLOPT_MAXREDIRS => 10,
	  CURLOPT_TIMEOUT => 0,
	  CURLOPT_FOLLOWLOCATION => true,
	  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
	  CURLOPT_CUSTOMREQUEST => "GET",
	  CURLOPT_HTTPHEADER => array(
       
		"Content-Type: application/json",
		"Authorization-Token: $gwanyoApiKey", 
	  ),
	));
	     
	$response = curl_exec($curl);
	$response=json_decode($response, true) ;
    curl_close($curl);


    $status=$response['status'];
    $funds=0;
    if($status == "success"){
        $funds=$response['data']['funds'];
    }
    return $funds;
}


?>