<?php
require $_SERVER['DOCUMENT_ROOT']."$stream/includes/conn.php";
require $_SERVER['DOCUMENT_ROOT']."$stream/includes/checkstring.php";
session_destroy() ;


function sendResponse($status, $message, $data=['status' => 'failed']) {
	$response=array("status" => $status, "message" => $message, "data" => $data) ;
	return json_encode($response) ;
} 

function requestMethod($method) {
	$requestMethod=strtoupper($_SERVER["REQUEST_METHOD"]);
	if($method != $requestMethod) {
		$status="error" ;
		$message="Method not allowed" ;
		echo sendResponse($status, $message) ;
		exit ;
	} 
} 
function checkPost($reqPosts, $rawData){
	$counter=0;
	$postFieldLen=count($reqPosts);
	foreach($reqPosts as $key => $reqPost){
		if(!array_key_exists($key, $rawData)){
			$status="error";
			$message="Required parameter($key) is missing";
			echo sendResponse($status, $message);
			break;
		}
		else{
			$counter++;
		}

	}
	return array("counter" => $counter, "postFieldLen" => $postFieldLen);
}
function api($method, $postFields){
	global $username, $funds, $email, $rawData;
	$clientReference=(isset($rawData['clientReference'])) ? $rawData['clientReference'] : "";
	$newPostFields=array("channel" => "api", "username" => $username, "funds" => $funds, "email" => $email, "clientReference" => $clientReference);
	$postFields=array_merge($postFields, $newPostFields);
	$token="BruteForceAPI-trhhfdffer";
	
	$url="https://gwanyoconnect.com.ng/app/actions/topup";

	$curl = curl_init();
	
	curl_setopt_array($curl, array(
	  CURLOPT_URL => $url,
	  CURLOPT_RETURNTRANSFER => true,
	  CURLOPT_ENCODING => "",
	  CURLOPT_MAXREDIRS => 10,
	  CURLOPT_TIMEOUT => 0,
	  CURLOPT_FOLLOWLOCATION => true,
	  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
	  CURLOPT_POSTFIELDS =>$postFields,
	  CURLOPT_CUSTOMREQUEST => $method,
	  CURLOPT_HTTPHEADER => array(
		"Authorization-Token: $token", 
	  ),
	));
	
	$response = curl_exec($curl);
	curl_close($curl);
	return $response;
}

requestMethod($method) ;

$headers=getallheaders() ;
$headers=array_change_key_case($headers, CASE_LOWER) ;
if(isset($headers['authorization-token'])) {
	$token=filter_string($headers['authorization-token']);
	$sql=$link->prepare("SELECT * FROM apitoken WHERE token=?") ;
	$sql->bind_param("s", $token) ;
	$sql->execute() ;
	$result=$sql->get_result() ;
	$numrow=$result->num_rows ;
	if($numrow == 0){
		$status="error" ;
		$message="Invalid authorization token" ;
		echo sendResponse($status, $message) ;
		exit ;
	} 
	else {
		$row=$result->fetch_assoc() ;
		$username=$row['username'] ;
		$sql=$link->prepare("SELECT * FROM users WHERE username=?") ;
		$sql->bind_param("s", $username) ;
		$sql->execute() ;
		$result=$sql->get_result() ;
		$row=$result->fetch_assoc() ;
		
		$funds=$row['funds'] ;
		$email=$row['email'] ;
	} 
	
} 
else {
	$status="error" ;
	$message="Authorization token was not found " ;
	echo sendResponse($status, $message) ;
	exit ;
} 


$fp = fopen('php://input', 'r');
$rawData = stream_get_contents($fp);
$rawData=json_decode($rawData, true) ;

?>