<?php
$genMsg="";
if(isset($_POST['updatePsw'])){

    if(empty($_POST['currPsw'])){
        $status="error";
        $message="Enter your current password"; 
        $genMsg=sendResponse($status, $message);
    }
    else if(empty($_POST['newPsw'])){
        $status="error";
        $message="Enter your new password";
        $genMsg=sendResponse($status, $message);
    }
    else if(strlen($_POST['newPsw']) < 8){
        $status="error";
        $message="Password must be at least 8 characters";
        $genMsg=sendResponse($status, $message);
    }
    else if(empty($_POST['confirmPsw'])){
        $status="error";
        $message="Confirm your password";
        $genMsg=sendResponse($status, $message);
    }
    else if($_POST['newPsw'] != $_POST['confirmPsw']){
        $status="error";
        $message="Passwords does not match";
        $genMsg=sendResponse($status, $message);
    }
    else{
        $currPsw=filter_string($_POST['currPsw']);
        $password=sha1($currPsw);

    
        if(!password_verify($password, $hashedPassword)){
            $status="error";
            $message="Current password is incorrect";
            $genMsg=sendResponse($status, $message);   
        }
        else{
            $newPsw=filter_string($_POST['newPsw']);
            $password=sha1($newPsw);
            
            $password=password_hash($password, PASSWORD_DEFAULT);
            $sql=$link->prepare("UPDATE users SET password=? WHERE username=?");
            $sql->bind_param("ss", $password, $username);
            if($sql->execute()){
                $status="success";
                $message="Password has been updated";
                $genMsg=sendResponse($status, $message);
            }
            else{
                $status="error";
                $message="Failed to update password";
                $genMsg=sendResponse($status, $message);
            }        
        }
    }
}



$showModalPin=true;
if(isset($_POST['updatePIN'])){

    if(empty($_POST['currPin']) && $hashedPin !=""){
        $status="error";
        $message="Enter your current pin"; 
        $genMsg=sendResponse($status, $message);
    }
    else if(empty($_POST['newPin'])){
        $status="error";
        $message="Enter your new pin";
        $genMsg=sendResponse($status, $message);
    }
    else if(strlen($_POST['newPin']) < 4){
        $status="error";
        $message="Pin must be 4 digits";
        $genMsg=sendResponse($status, $message);
    }
    else if(empty($_POST['confirmPin'])){
        $status="error";
        $message="Confirm your pin";
        $genMsg=sendResponse($status, $message);
    }
    else if($_POST['newPin'] != $_POST['confirmPin']){
        $status="error";
        $message="Pins does not match";
        $genMsg=sendResponse($status, $message);
    }
    else{
        $currPin=isset($_POST['currPin']) ? filter_string($_POST['currPin']) : "";

        if(!password_verify(sha1($currPin), $hashedPin) && $hashedPin !=""){
            $status="error";
            $message="Current pin is incorrect";
            $genMsg=sendResponse($status, $message);   
        }
        else{
            $newPin=filter_string($_POST['newPin']);
            $trxPin=password_hash(sha1($newPin), PASSWORD_DEFAULT);
            $sql=$link->prepare("UPDATE users SET trxpin=? WHERE username=?");
            $sql->bind_param("ss", $trxPin, $username);
            if($sql->execute()){
                $showModalPin=false;
                $status="success";
                $message="Transaction Pin has been updated";
                $genMsg=sendResponse($status, $message);
            }
            else{
                $status="error";
                $message="Failed to update pin";
                $genMsg=sendResponse($status, $message);
            }        
        }
    }
}




function randNum($length){
    $randNum=mt_rand(000000, 999999);
    if(strlen($randNum) != $length){
        randNum($length);
    }
    return $randNum;
}

$displayBtnModal=true;
$displayPinModal=false;
if(isset($_POST['forgotPIN'])){
    $displayEmailModal=true;
    $sql=$link->prepare("DELETE FROM otp WHERE email=?");
    $sql->bind_param("s", $email);
    if($sql->execute()){
        $otp=randNum(6);
        $hashedOtp=password_hash(SHA1($otp), PASSWORD_DEFAULT);
        $sql=$link->prepare("INSERT INTO otp(email, otp, date) VALUES(?,?,?)");
        $sql->bind_param("sss", $email, $hashedOtp, $dateTime);
        if($sql->execute()){
            $subject="Transaction PIN Reset";
            $message="Hello $fullname, kindly use this code $otp to verify your pin reseting.";
            $sendMail=sendMail($email, $fullname, $message, $subject);
            if($sendMail['status'] == "success"){
                $displayPinModal="true";
                $displayBtnModal="false";
                $status="success";
                $message="Verification Code has been sent to your email address, enter the code below, check spam box if not found in inbox";
                $genMsg=sendResponse($status, $message);
            }
            else{
                $status="error";
                $message="Could not reset pin";
                $genMsg=sendResponse($status, $messge);
            }
        }
        else{
            $status="error";
            $message="Something went wrong 002";
            $genMsg=sendResponse($status, $messge);
        }
    }
    else{
        $status="error";
        $message="Something went wrong 001";
        $genMsg=sendResponse($status, $messge);
    }
}

if(isset($_POST['proceedVerification'])){
    if(empty($_POST['otp'])){
        $status="error";
        $message="Enter the code sent to your email address";
        $genMsg=sendResponse($status, $message);
    }
    else if(empty($_POST['newPin'])){
        $status="error";
        $message="Enter your new pin";
        $genMsg=sendResponse($status, $message);
    }
    else if(strlen($_POST['newPin']) < 4){
        $status="error";
        $message="Pin must be 4 digits";
        $genMsg=sendResponse($status, $message);
    }
    else if(empty($_POST['confirmPin'])){
        $status="error";
        $message="Confirm your pin";
        $genMsg=sendResponse($status, $message);
    }
    else if($_POST['newPin'] != $_POST['confirmPin']){
        $status="error";
        $message="Pins does not match";
        $genMsg=sendResponse($status, $message);
    }
    else{
        $otp=filter_string($_POST['otp']);
        $otp=SHA1($otp);
        $sql=$link->prepare("SELECT * FROM otp WHERE email=?");
        $sql->bind_param("s", $email);
        $sql->execute();
        $result=$sql->get_result();
        $numrow=$result->num_rows;
        $row=$result->fetch_assoc();
        if($numrow == 1){
            $hashedOtp=$row['otp'];
            if(password_verify($otp, $hashedOtp)){
                $newPin=filter_string($_POST['newPin']);
                $trxPin=password_hash(sha1($newPin), PASSWORD_DEFAULT);
                
                $sql=$link->prepare("UPDATE users SET trxpin=? WHERE username=?");
                $sql->bind_param("ss", $trxPin, $username);
                if($sql->execute()){
                    $sql=$link->prepare("DELETE FROM otp WHERE email=?");
                    $sql->bind_param("s", $email);
                    if($sql->execute()){
                        $status="success";
                        $message="Transaction Pin has been updated";
                        $genMsg=sendResponse($status, $message);
                    }
                    else{
                        $status="error";
                        $message="Something wet wrong";
                        $genMsg=sendResponse($status, $message);
                    }
                }
                else{
                    $status="error";
                    $message="Failed to reset Transaction PIN";
                    $genMsg=sendResponse($status, $message);
                }
            }
            else{
                $status="error";
                $message="Otp is incorrect, please check your mail very well";
                $genMsg=sendResponse($status, $message);
            }
        }
        else{
            $status="error";
            $message="Otp is incorrect, please check your mail very well";
            $genMsg=sendResponse($status, $message);
        }
    }
}


?>