<?php
require $_SERVER['DOCUMENT_ROOT']."/stream.php";
require $_SERVER['DOCUMENT_ROOT']."$stream/includes/generalinclude.php";
require $_SERVER['DOCUMENT_ROOT']."$stream/includes/topup.php";


$headers=getallheaders() ;
$headers=array_change_key_case($headers, CASE_LOWER) ; 
if(empty($_POST['channel'])) {
    require $_SERVER['DOCUMENT_ROOT']."$stream/app/includes/generalinclude.php";
	$channel=$role == "reseller" ? "reseller" : "dashboard" ;
} 
else if(isset($headers['authorization-token']) && $headers['authorization-token'] == "BruteForceAPI-trhhfdffer"){
	$channel=filter_string($_POST['channel']) ;
	$username=filter_string($_POST['username']) ;
	$funds=filter_string($_POST['funds']) ;
	$email=filter_string($_POST['email']) ;
	$role="";
}  

function validateTrxPin($trxPin){
	global $hashedPin, $channel;
	if($channel == "dashboard"){
		if($hashedPin == "") {
			$status="error" ;
			$message="Transaction pin not set. Set pin in settings." ;
            $data=[
                "status" => "failed",
                "channel" => "api",
                "isPin" => true,
                "isPinR" => true
            ];
            echo sendResponse($status, $message, $data);
			exit;
		}
		else if(empty($trxPin)){
			$status="error" ;
			$message="Enter your transaction pin" ;
            $data=[
                "status" => "failed",
                "channel" => "api",
                "isPin" => true,
                "isPinR" => false
            ];
            echo sendResponse($status, $message, $data);
			exit;
		}
		else if(!password_verify(SHA1($trxPin), $hashedPin)){
			$status="error" ;
			$message="Transaction Pin is incorrect";
            $data=[
                "status" => "failed",
                "channel" => 'api',
                "isPin" => true,
                "isPinR" => false
            ];
            echo sendResponse($status, $message, $data);
			exit;
		}
	}
}

if(isset($_POST['buyAirtime']) && !empty($_POST['buyAirtime'])){
    if(empty($_POST['serviceID'])){
        $status="error";
        $message="Fatal error: Something went wrong";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(empty($_POST['amount'])){
        $status="error";
        $message="Enter an amount";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(!is_numeric($_POST['amount'])){
        $status="error";
        $message="Enter a valid amount";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if($_POST['amount'] < 100){
        $status="error";
        $message="Minimum airtime topup is NGN100";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(empty($_POST['phone'])){
        $status="error";
        $message="Enter a phone number";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(!is_numeric($_POST['phone'])){
        $status="error";
        $message="Enter a valid phone number";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(strlen($_POST['phone']) != 11){
        $status="error";
        $message="Enter a valid phone number";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else{
        validateTrxPin($_POST['trxPin']);
        $serviceID=filter_string($_POST['serviceID']);
        $amount=filter_string($_POST['amount']);
        $phone=filter_string($_POST['phone']); 

        $sql=$link->prepare("SELECT * FROM airtimeprices WHERE serviceid=? AND allow='true' ");
        $sql->bind_param("s", $serviceID);
        $sql->execute();
        $result=$sql->get_result();
        $numrow=$result->num_rows;
        $row=$result->fetch_assoc();
        if($numrow == 0){
            $status="error";
            $message=$channel == "dashboard" ? "Something went wrong validating airtime" : "Service ID is incorrect";
            $data=[
                "status" => "failed",
                "channel" => $channel
            ];
            echo sendResponse($status, $message, $data);
            exit;
        }
        $merchant=$row['merchant'];
        $discount=$channel=="api" ? $row['apidiscount'] : $row['discount'];
        $discount=$role=="reseller" ? $row['resellerdiscount'] : $discount;
        $network=$row['network'];
        $apiServiceID=$row['apiserviceid'];
        $discountAmount=$amount - ($discount * $amount / 100);
        //$discountAmount=productDiscount($discountAmount);
       
        
        if($discountAmount > $funds){
            $status="error";
            $message="Insuffucient funds";
            $data=[
                "status" => "failed",
                "channel" => $channel
            ];
            echo sendResponse($status, $message, $data);
            exit;
        }
        else if($amount < 50){
            $status="error";
            $message="Amount must be greater than 50";
            $data=[
                "status" => "failed",
                "channel" => $channel
            ];
            echo sendResponse($status, $message, $data);
            exit;
        }


        $sql=$link->prepare("UPDATE users SET funds=funds - ? WHERE username=?");
        $sql->bind_param("ss", $discountAmount, $username);
        if($sql->execute()){
            $ownReference=get_rand_alphanumeric(30);
            $data=array("serviceID" => $apiServiceID, "amount" => $amount, "phone" => $phone, "reference" => $ownReference, "merchant" => $merchant);
            $buyAirtime=buyAirtime($data);
            $airtimeStatus=$airtimeMessage="";
            if(isset($buyAirtime['status'])){
                $airtimeStatus=$buyAirtime['status'];
                $airtimeMessage=$buyAirtime['message'];
            }

            $type="airtime";
            $desc=strtoupper($network). " airtime";
            $status="pending";
            $sql=$link->prepare("INSERT INTO transactions(username, serviceid, type, amount, balbefore, amountcharged, number, description, status, ownreference, channel, merchant, date) VALUES(?,?,?,?,?,?,?,?,?,?,?,?,?)");
            $sql->bind_param("sssssssssssss", $username, $serviceID, $type, $amount, $funds, $discountAmount, $phone, $desc, $status, $ownReference, $channel, $merchant, $dateTime);
            $sql->execute();
            
            if($airtimeStatus == "success"){
                $status="successful";
                $apiReference=$buyAirtime['data']['apiReference'];
                $trxStatus=$buyAirtime['data']['status'];
                $balAf=$funds - $amount;
                $sql=$link->prepare("UPDATE transactions SET apireference=?, balafter=?, status=?, message=? WHERE ownreference=?");
                $sql->bind_param("sssss", $apiReference, $balAf, $status, $airtimeMessage, $ownReference);
                if($sql->execute()){
                    $status="success";
                    $message="Airtime purchase successful";
                    $data=[
                        "type" => "airtime",
                        "reference" => $ownReference,
                        "amount" => $amount,
                        "amountCharged" => $discountAmount,
                        "phoneNumber" => $phone,
                        "network" => $network,
                        "status" => $trxStatus,
                        "channel" => $channel
                    ];
                    echo sendResponse($status, $message, $data);
                }
                else{
                    $status="error";
                    $message="Something went wrong";
                    $data=[
                        "status" => $trxStatus,
                        "channel" => $channel
                    ];
                    echo sendResponse($status, $message, $data);
                }
            }
            else{
                $status="pending";
                $expMsgs=array("Insufficient balance on your account", "Invalid Access Token", "Insufficient funds"); 
                if(in_array($airtimeMessage, $expMsgs) || $buyAirtime['data']['status'] == "failed"){
                    $status="failed"; 
                    $sql=$link->prepare("UPDATE users SET funds=funds + ? WHERE username=?");
                    $sql->bind_param("ss", $discountAmount, $username);
                    $sql->execute();
                }
                $sql=$link->prepare("UPDATE transactions SET status=?, balafter=?, message=? WHERE ownreference=?");
                $sql->bind_param("ssss", $status, $funds, $airtimeMessage, $ownReference);
                $sql->execute();
                $message="Could not buy airtime at this time, try again later";
                $data=[
                    "status" => $status,
                    "channel" => $channel
                ];
                $status="error";
                echo sendResponse($status, $message, $data);
            } 
        }
        else{
            $status="error";
            $message="Something went wrong";
            $data=[
                "status" => "failed",
                "channel" => $channel
            ];
            echo sendResponse($status, $message, $data);
        }
    }
}

if(isset($_POST['airtimeToCash']) && !empty($_POST['airtimeToCash'])){
    $networks=['mtn', 'glo', 'airtel', '9mobile'];
    if(empty($_POST['network'])){
        $status="error";
        $message="Select network";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(!in_array($_POST['network'], $networks)){
        $status="error";
        $message="Select a valid network";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(empty($_POST['amount'])){
        $status="error";
        $message="Enter an amount";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(!is_numeric($_POST['amount'])){
        $status="error";
        $message="Enter a valid amount";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if($_POST['amount'] < 100){
        $status="error";
        $message="Minimum airtime topup is NGN100";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(empty($_POST['phone'])){
        $status="error";
        $message="Enter a phone number";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(!is_numeric($_POST['phone'])){
        $status="error";
        $message="Enter a valid phone number";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(strlen($_POST['phone']) != 11){
        $status="error";
        $message="Enter a valid phone number";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else{
        validateTrxPin($_POST['trxPin']);
        $network=filter_string($_POST['network']);
        $amount=filter_string($_POST['amount']);
        $phone=filter_string($_POST['phone']); 

        $sql=$link->prepare("SELECT * FROM airtime2cashprices WHERE allow='true' ");
        $sql->execute();
        $result=$sql->get_result();
        $numrow=$result->num_rows;
        $row=$result->fetch_assoc();
        if($numrow == 0){
            $status="error";
            $message= "Airtime to cash is not avaliable at the moment";
            $data=[
                "status" => "failed",
                "channel" => $channel
            ];
            echo sendResponse($status, $message, $data);
            exit;
        }
        $numberToSend=$row[$network];
        $fee= $row['fee'];
        $amountToGet=$amount - ($fee * $amount / 100);
        //$amountToGet=productDiscount($amountToGet);
        $phone="$phone \n $numberToSend";

        $ownReference=get_rand_alphanumeric(15);
        $type="airtime2cash";
        $desc=strtoupper($network). " airtime2cash";
        $status="pending";
        $merchant="--";
        $balAf=$funds - $amount;
        $sql=$link->prepare("INSERT INTO transactions(username, serviceid, type, amount, balbefore, balafter, amountcharged, number, description, status, ownreference, channel, merchant, date) VALUES(?,?,?,?,?,?,?,?,?,?,?,?,?,?)");
        $sql->bind_param("ssssssssssssss", $username, $serviceID, $type, $amount, $funds, $balAf, $amountToGet, $phone, $desc, $status, $ownReference, $channel, $merchant, $dateTime);
        if($sql->execute()){
            $status="success";
            $message="Airtime to cash request has been sent.";
            $data=[
                "status" => "failed",
                "channel" => $channel
            ];
            echo sendResponse($status, $message, $data);
        }
        else{
            $status="error";
            $message="Something went wrong";
            $data=[
                "status" => "failed",
                "channel" => $channel
            ];
            echo sendResponse($status, $message, $data);
        }
    }
}


if(isset($_POST['buyData']) && !empty($_POST['buyData'])){
    $networks=array("mtn","airtel","9mobile","glo");
    if(empty($_POST['serviceID'])){
        $status="error";
        $message="Select dataplan";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(!is_numeric($_POST['serviceID'])){
        $status="error";
        $message="Select dataplan";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(empty($_POST['phone'])){
        $status="error";
        $message="Enter a phone number";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(!is_numeric($_POST['phone'])){
        $status="error";
        $message="Enter a valid phone number";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(strlen($_POST['phone']) != 11){
        $status="error";
        $message="Enter a valid phone number";
        $data=[
            "status" => "failed",
            "channel" => $channel 
        ];
        echo sendResponse($status, $message, $data);
    }
    else{
        if($channel !=="api"){
            validateTrxPin($_POST['trxPin']);
        }
        //validateTrxPin($_POST['trxPin']);
        $serviceID=filter_string($_POST['serviceID']);
        $phone=filter_string($_POST['phone']);

        $sql=$link->prepare("SELECT * FROM dataprices WHERE serviceid=? AND allow='true' ");
        $sql->bind_param("s", $serviceID);
        $sql->execute();
        $result=$sql->get_result();
        $numrow=$result->num_rows;
        $row=$result->fetch_assoc();
        if($numrow == 0){
            $status="error";
            $message=$channel == "dashboard" ? "Something went wrong validating data" : "Service ID is incorrect";
            $data=[
                "status" => "failed",
                "channel" => $channel
            ];
            echo sendResponse($status, $message, $data);
            exit;
        }
        $merchant=$row['merchant'];
        $amount=$channel=="api" ? $row['apiamount'] : $row['amount'];
        $amount=$role=="reseller" ? $row['reselleramount'] : $amount;
        //$amount=productDiscount($amount);
        $network=$row['network'];
        $dataPlan=$row['dataplan'];
        $dataType=$row['datatype'];
        $apiServiceID=$row['apiserviceid'];
        $networkID=$row['networkid'];
        $desc=strtoupper($network)." ".$dataPlan;
        if($amount > $funds){
            $status="error";
            $message="Insuffucient funds";
            $data=[
                "status" => "failed",
                "channel" => $channel
            ];
            echo sendResponse($status, $message, $data);
            exit;
        }
        
        $sql=$link->prepare("UPDATE users SET funds=funds - ? WHERE username=?");
        $sql->bind_param("ss", $amount, $username);
        if($sql->execute()){
            $ownReference=get_rand_alphanumeric(30);
            $data=array("networkID" => $networkID, "phone" => $phone, "reference" => $ownReference, "serviceID" => $apiServiceID, "merchant" => $merchant);
            $buyData=buyData($data);
            $dataStatus=$dataMessage="";
            if(isset($buyData['status'])){
                $dataStatus=$buyData['status'];
                $dataMessage=$buyData['message'];
            }

            $type="data";
            $status="pending";
            $sql=$link->prepare("INSERT INTO transactions(username, serviceID, type, amount, balbefore, number, description, status, ownreference, channel, merchant, date) VALUES(?,?,?,?,?,?,?,?,?,?,?,?)");
            $sql->bind_param("ssssssssssss", $username, $serviceID, $type, $amount, $funds, $phone, $desc, $status, $ownReference, $channel, $merchant, $dateTime);
            $sql->execute();
            
            
            if($dataStatus == "success"){
                $status="successful";
                $apiReference=$buyData['data']['apiReference'];
                $amountCharged=$buyData['data']['amount'];
                $trxStatus=$buyData['data']['status'];
                $balAf=$funds - $amount;
                $sql=$link->prepare("UPDATE transactions SET apireference=?, amountcharged=?, balafter=?, status=?, message=? WHERE ownreference=?");
                $sql->bind_param("ssssss", $apiReference, $amount, $balAf, $status, $dataMessage, $ownReference);
                if($sql->execute()){
                    //if($acctType == "standard" || $acctType == "free"){
                     //   $dataPlanMB=0;
                    //    switch($dataPlan){
                      //      case "500MB"   : $dataPlanMB =  "500";  break;
                     //       case "1GB"     : $dataPlanMB =  "1000"; break;
                       //     case "1.35GB"  : $dataPlanMB =  "1350"; break;
                      //      case "1.5GB"   : $dataPlanMB =  "1500"; break;
                       //     case "2GB"     : $dataPlanMB =  "2000"; break;
                       //     case "2.90GB"  : $dataPlanMB =  "2900"; break;
                     //       case "3GB"     : $dataPlanMB =  "3000"; break;
                       //     case "4.10GB"  : $dataPlanMB =  "4100"; break;
                      //      case "5GB"     : $dataPlanMB =  "5000"; break;
                       //     case "5.80GB"  : $dataPlanMB =  "5800"; break;
                      //      case "10GB"    : $dataPlanMB =  "10000"; break;
                      //      case "11GB"    : $dataPlanMB =  "11000"; break;
                      //  }
                     //   $cashBackData=$cashBackData * $dataPlanMB / 100;
                      //  $sql=$link->prepare("UPDATE users SET datafunds=datafunds + ? WHERE username=?");
                   //     $sql->bind_param("ss", $cashBackData, $username);
                    //    $sql->execute();
                   // }
                    $status="success";
                    $message="Data purchase successful";
                    $data=[
                        "type" => "data",
                        "network" => $network,
                        "dataPlan" => $dataPlan,
                        "dataType" => $dataType,
                        "amount" => $amount,
                        "status" => $trxStatus,
                        "channel" => $channel
                    ];
                    echo sendResponse($status, $message, $data);
                }
                else{
                    $status="error";
                    $message="Something went wrong";
                    $data=[
                        "status" => $trxStatus,
                        "channel" => $channel
                    ];
                    echo sendResponse($status, $message, $data);
                }
            }
            else{
                $status="pending";
                $expMsgs=array("Insufficient balance on your account", "Authorization token is incorrect");
                if(in_array($dataMessage, $expMsgs) || $buyData['data']['status'] == "failed"){
                    $status="failed";
                    $sql=$link->prepare("UPDATE users SET funds=funds + ? WHERE username=?");
                    $sql->bind_param("ss", $amount, $username);
                    $sql->execute();
                }
                $sql=$link->prepare("UPDATE transactions SET balafter=?, status=?, message=? WHERE ownreference=?");
                $sql->bind_param("ssss", $funds, $status, $dataMessage, $ownReference);
                $sql->execute();
                $message="Could not buy data at this time, try again later";
                $data=[
                    "status" => $status,
                    "channel" => $channel
                ];
                $status="error";
                echo sendResponse($status, $message, $data);
            }
        }
        else{
            $status="error";
            $message="Something went wrong";
            $data=[
                "status" => "failed",
                "channel" => $channel
            ];
            echo sendResponse($status, $message, $data);
        }
    }
}

if(isset($_POST['validateCable']) && !empty($_POST['validateCable'])){
    $cables=array("gotv","dstv","startimes");
    if(empty($_POST['cable']) && $channel == "dashboard"){
        $status="error";
        $message="Select cable";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(!in_array($_POST['cable'], $cables) && $channel == "dashboard"){
        $status="error";
        $message="Invalid cable";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(empty($_POST['iucNum'])){
        $status="error";
        $message="Enter IUC Number";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(!is_numeric($_POST['iucNum'])){
        $status="error";
        $message="Invalid IUC Number";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(empty($_POST['serviceID'])){
        $status="error";
        $message="Enter Cable plan";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(!is_numeric($_POST['serviceID'])){
        $status="error";
        $message="Invalid cable plan";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else{
        $iucNum=filter_string($_POST['iucNum']);
        $serviceID=filter_string($_POST['serviceID']);
        $sql=$link->prepare("SELECT * FROM cableprices WHERE serviceid=? AND merchant='ncwallet' ");
        $sql->bind_param("s", $serviceID);
        $sql->execute();
        $result=$sql->get_result();
        $numrow=$result->num_rows;
        $row=$result->fetch_assoc();
        if($numrow == 0){
            $status="error";
            $message=$channel == "dashboard" ? "Something went wrong validating cable" : "Service ID is incorrect";
            $data=[
                "status" => "failed",
                "channel" => $channel
            ];
            echo sendResponse($status, $message, $data);
            exit;
        }
        $cableID=$row['cableid'];
        $cable=$row['cable'];
        $data=array("cableID" => $cableID, "serviceID" => $serviceID, "iucNum" => $iucNum, "cable" => $cable);
        $validateCable=validateCable($data);
        if(isset($validateCable['status']) && $validateCable['status'] == "success"){
            $dataStatus=$validateCable['status'];
            $dataMessage=$validateCable['message'];
            $customerName=$validateCable['data']['customerName'];
            $currentBouquet=$validateCable['data']['currentBouquet'];

            $status="success";
            $message="Validation successful";
            $data=array("customerName" => $customerName, "currentBouquet" => $currentBouquet);
            echo json_encode(array("status" => $status, "message" => $message, "data" => $data));
        }
        else{
            $status="error";
            $message="Validation failed";
            $data=[];
            echo json_encode(array("status" => $status, "message" => $message, "data" => $data));
        }
    }
}

if(isset($_POST['subCable']) && !empty($_POST['subCable'])){
    $cables=array("gotv","dstv","startimes");
    if(empty($_POST['serviceID'])){
        $status="error";
        $message="Select cable plan";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(!is_numeric($_POST['serviceID'])){
        $status="error";
        $message="Select cable plan";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(empty($_POST['cable']) && $channel == "dashboard"){
        $status="error";
        $message="Select your cable";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(empty($_POST['iucNum'])){
        $status="error";
        $message="Enter your IUC number";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(!is_numeric($_POST['iucNum'])){
        $status="error";
        $message="Enter a valid IUC number";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(!in_array($_POST['cable'], $cables) && $channel == "dashboard"){
        $status="error";
        $message="Invalid cable";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else{
        validateTrxPin($_POST['trxPin']);
        $serviceID=filter_string($_POST['serviceID']);
        $iucNum=filter_string($_POST['iucNum']);

        $sql=$link->prepare("SELECT * FROM cableprices WHERE serviceid=? AND allow='true' ");
        $sql->bind_param("s", $serviceID);
        $sql->execute();
        $result=$sql->get_result();
        $numrow=$result->num_rows;
        $row=$result->fetch_assoc();
        if($numrow == 0){
            $status="error";
            $message=$channel == "dashboard" ? "Something went wrong validating cable" : "Service ID is incorrect";
            $data=[
                "status" => "failed",
                "channel" => $channel
            ];
            echo sendResponse($status, $message, $data);
            exit;
        }
        $merchant=$row['merchant'];
        $cableID=$row['cableid'];
        $amount=$channel == "dashboard" ? $row['amount'] : $row['apiamount'];        
        $amount=$role=="reseller" ? $row['reselleramount'] : $amount;
        $cable=$row['cable'];
        $apiServiceID=$row['apiserviceid'];
        //$amount=(int)productDiscount($amount);
        $cablePlan=$row['plan'];
        $desc=strtoupper($cable)." ".$cablePlan;
        if($amount > $funds){
            $status="error";
            $message="Insuffucient funds";
            $data=[
                "status" => "failed",
                "channel" => $channel
            ];
            echo sendResponse($status, $message, $data);
            exit;
        }
        $sql=$link->prepare("UPDATE users SET funds=funds - ? WHERE username=?");
        $sql->bind_param("ss", $amount, $username);
        if($sql->execute()){
            $reference=get_rand_alphanumeric(20);
            $data=array("serviceID" => $apiServiceID, "iucNum" => $iucNum, "cableID" => $cableID, "cable" => $cable, "reference" => $reference, "merchant" => $merchant);
            $subCable=subCable($data);
            $dataStatus=$dataMessage="";
            if(isset($subCable['status'])){
                $cableStatus=$subCable['status'];
                $cableMessage=$subCable['message'];
            }

            $type="cable";
            $balAF=$funds - $amount;
            $status="successful";
            if($cableStatus == "success"){
                $apiReference=$subCable['data']['apiReference'];
                $sql=$link->prepare("INSERT INTO transactions(username, serviceID, type, apireference, amount, balbefore, balafter, amountcharged, number, description, status, message, ownreference, channel, merchant, date) VALUES(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)");
                $sql->bind_param("ssssssssssssssss", $username, $serviceID, $type, $apiReference, $amount, $funds, $balAF, $amount, $iucNum, $desc, $status, $cableMessage, $reference, $channel, $merchant, $dateTime);
                if($sql->execute()){
                    $status="success";
                    $message="Cable subscription successful";
                    $data=[
                        "type" => "cable",
                        "amount" => $amount,
                        "reference" => $reference,
                        "iucNum" => $iucNum,
                        "cable" => $cable,
                        "status" => "success",
                        "channel" => $channel
                    ];
                    echo sendResponse($status, $message, $data);
                }
                else{
                    $status="error";
                    $message="Something went wrong";
                    $data=[
                        "status" => "success",
                        "channel" => $channel
                    ];
                    echo sendResponse($status, $message, $data);
                }
            }
            else{
                $sql=$link->prepare("UPDATE users SET funds=funds + ? WHERE username=?");
                $sql->bind_param("ss", $amount, $username);
                if($sql->execute()){
                    $status="error";
                    $message="Could not subscribe at this time, try again later";
                    $message=$cableMessage;
                    $data=[
                        "status" => "failed",
                        "channel" => $channel
                    ];
                    echo sendResponse($status, $message, $data);
                }
            }
        }
        else{
            $status="error";
            $message="Something went wrong";
            $data=[
                "status" => "failed",
                "channel" => $channel
            ];
            echo sendResponse($status, $message, $data);
        }
    }
}


if(isset($_POST['validateElectric']) && !empty($_POST['validateElectric'])){
    if(empty($_POST['serviceID'])){
        $status="error";
        $message="Select meter company";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(empty($_POST['meterNum'])){
        $status="error";
        $message="Enter meter Number";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(!is_numeric($_POST['meterNum'])){
        $status="error";
        $message="Invalid meter Number";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(empty($_POST['amount'])){
        $status="error";
        $message="Enter amount";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(!is_numeric($_POST['amount'])){
        $status="error";
        $message="Invalid amount";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if($_POST['amount'] < 1000){
        $status="error";
        $message="Enter amount greater or equal to 1000";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(empty($_POST['meterType'])){
        $status="error";
        $message="Select meter type";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(!is_numeric($_POST['meterType'])){
        $status="error";
        $message="Invalid meter type";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else{
        $serviceID=filter_string($_POST['serviceID']);
        $meterNum=filter_string($_POST['meterNum']);
        $meterType=filter_string($_POST['meterType']);
        $amount=filter_string($_POST['amount']);
        
        $sql=$link->prepare("SELECT * FROM electricityprices WHERE serviceid=? AND merchant='ncwallet' "); 
        $sql->bind_param("s", $serviceID);
        $sql->execute();
        $result=$sql->get_result();
        $numrow=$result->num_rows;
        $row=$result->fetch_assoc();
        if($numrow == 0){
            $status="error";
            $message=$channel == "dashboard" ? "Something went wrong validating meter" : "Service ID is incorrect";
            $data=[
                "status" => "failed",
                "channel" => $channel
            ];
            echo sendResponse($status, $message, $data);
            exit;
        }
        $merchant=$row['merchant'];
        $apiServiceID=$row['apiserviceid'];

        $data=array("serviceID" => $apiServiceID, "meterNum" => $meterNum, "meterType" => $meterType, "amount" => $amount);
        $validateElectric=validateElectric($data);
        $dataStatus=$dataMessage="";
        if(isset($validateElectric['status']) && $validateElectric['status'] == "success"){
            $electricStatus=$validateElectric['status'];
            $electriMessage=$validateElectric['message'];
            $customerName=$validateElectric['data']['customerName'];
            // $address=$validateElectric['data']['address'];
            $address="";

            $status="success";
            $message="Validation successful";
            $data=array("customerName" => $customerName, "address" => $address);
            echo json_encode(array("status" => $status, "message" => $message, "data" => $data));
        }
        else{
            $status="error";
            $message="Validation failed";
            $data=array("");
            echo json_encode(array("status" => $status, "message" => $message, "data" => $data));
        }
    }
}


if(isset($_POST['payElectric']) && !empty($_POST['payElectric'])){
    $cables=array("gotv","dstv","startimes");
    if(empty($_POST['serviceID'])){
        $status="error";
        $message="Select meter company";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(empty($_POST['companyName']) && $channel == "dashboard"){
        $status="error";
        $message="Enter meter company";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(empty($_POST['meterNum'])){
        $status="error";
        $message="Enter meter Number";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(!is_numeric($_POST['meterNum'])){
        $status="error";
        $message="Invalid meter Number";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(empty($_POST['amount'])){
        $status="error";
        $message="Enter amount";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(!is_numeric($_POST['amount'])){
        $status="error";
        $message="Invalid amount";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if($_POST['amount'] < 1000){
        $status="error";
        $message="Minimum amount is 1000";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(empty($_POST['meterType'])){
        $status="error";
        $message="Select meter type";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(!is_numeric($_POST['meterType'])){
        $status="error";
        $message="Invalid meter type";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else{
        validateTrxPin($_POST['trxPin']);
        $serviceID=filter_string($_POST['serviceID']);
        $meterNum=filter_string($_POST['meterNum']);
        $meterType=filter_string($_POST['meterType']);
        $amountM=(int)filter_string($_POST['amount']);
        //$amount=productDiscount($amountM);
        $reference=get_rand_alphanumeric(20);
        
        $sql=$link->prepare("SELECT * FROM electricityprices WHERE serviceid=? AND allow='true' ");
        $sql->bind_param("s", $serviceID);
        $sql->execute();
        $result=$sql->get_result();
        $numrow=$result->num_rows;
        $row=$result->fetch_assoc();
        if($numrow == 0){
            $status="error";
            $message=$channel == "dashboard" ? "Something went wrong validating meter" : "Service ID is incorrect";
            $data=[
                "status" => "failed",
                "channel" => $channel
            ];
            echo sendResponse($status, $message, $data);
            exit;
        }
        $disco=$row['disco'];
        $merchant=$row['merchant'];
        $apiServiceID=$row['apiserviceid'];
        $discount=$channel=="dashboard" ? $row['discount'] : $row['apidiscount'];
        $discount=$role=="reseller" ? $row['resellerdiscount'] : $discount;
        $discountAmount=$amount - ($discount * $amount / 100);
        $discountAmount=productDiscount($discountAmount);
        
        if($merchant == "ncwallet" && $meterType == "01"){
            $meterType="prepaid";
        }
        else if($merchant == "ncwallet" && $meterType == "02"){
            $meterType="postpaid";
        }
        
        if($discountAmount > $funds){
            $status="error";
            $message="Insuffucient funds";
            $data=[
                "status" => "failed",
                "channel" => $channel
            ];
            echo sendResponse($status, $message, $data);
            exit;
        }
        else if($amountM < 1000){
            $status="error";
            $message="Amount should be greater than 1000";
            $data=[
                "status" => "failed",
                "channel" => $channel
            ];
            echo sendResponse($status, $message, $data);
            exit;
        }
        $sql=$link->prepare("UPDATE users SET funds=funds - ? WHERE username=?");
        $sql->bind_param("ss", $amount, $username);
        if($sql->execute()){
            $reference=get_rand_alphanumeric(20);
            $data=array("serviceID" => $apiServiceID, "meterNum" => $meterNum, "meterType" => $meterType, "amount" => $amount, "merchant" => $merchant);
            $payElectric=payElectric($data);
            $electricStatus=$electricMessage="";
            if(isset($payElectric['status'])){
                $electricStatus=$payElectric['status'];
                $electricMessage=$payElectric['message'];
            }

            $type="electricity";
            if($electricStatus == "success"){
                $token=$payElectric['data']['token'];
                $customerName=$payElectric['data']['customerName'];
                $apiReference=$payElectric['data']['reference'];
                $electricAmount=$payElectric['data']['amount'];
                $units=$payElectric['data']['units'];

                $desc="$disco";
                $balAF=$funds - $amount;
                $status="successful";
                $sql=$link->prepare("INSERT INTO transactions(username, serviceid, type, ownreference, apireference, amount, balbefore, balafter, amountcharged, number, description, status, message, channel, merchant, date) VALUES(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)");
                $sql->bind_param("ssssssssssssssss", $username, $serviceID, $type, $reference, $apiReference, $amount, $funds, $balAF, $discountAmount, $meterNum, $desc, $status, $electricMessage, $channel, $merchant, $dateTime);
                if($sql->execute()){
                    $sql=$link->prepare("INSERT INTO electricity(username, reference, apireference, productname, serviceid, amount, amountpaid, apiamount, status, meternum, customername, token, units, date) VALUES(?,?,?,?,?,?,?,?,?,?,?,?,?,?)") ;
					$sql->bind_param("ssssssssssssss", $username, $reference, $apiReference, $disco, $serviceID, $amount, $discountAmount, $electricAmount, $status, $meterNum, $customerName, $token, $units, $dateTime) ;
                    $sql->execute();

                    $status="success";
                    $message="Electric payment successful";
                    $data=[
                        "type" => "electricity",
                        "token" => $token,
                        "customerName" => $customerName,
                        "amount" => $amount,
                        "amountCharged" => $discountAmount,
                        "reference" => $reference,
                        "meterNum" => $meterNum,
                        "disco" => $disco,
                        "status" => "success", 
                        "channel" => $channel
                    ];
                    echo sendResponse($status, $message, $data);
                }
                else{
                    $status="error";
                    $message="Something went wrong";
                     $data=[
                        "status" => "success",
                        "channel" => $channel
                    ];
                    echo sendResponse($status, $message, $data);
                }
            }
            else{
                $sql=$link->prepare("UPDATE users SET funds=funds + ? WHERE username=?");
                $sql->bind_param("ss", $discountAmount, $username);
                if($sql->execute()){
                    $status="error";
                    $message="Could not pay electricity at this time, try again later";
                     $data=[
                        "status" => "failed",
                        "channel" => $channel
                    ];
                    $message=$electricMessage;
                    echo sendResponse($status, $message, $data);
                }
            }
        }
        else{
            $status="error";
            $message="Something went wrong";
             $data=[
                "status" => "failed",
                "channel" => $channel
            ];
            echo sendResponse($status, $message, $data);
        }
    }
}

if(isset($_POST['educationalPin']) && !empty($_POST['educationalPin'])) {
	$quantities=array(1,2,5);

	if(empty($_POST['serviceID'])) {
		$status="error" ;
		$message="Select Education type" ;
         $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
	}
	else if(!is_numeric($_POST['serviceID'])) {
		$status="error" ;
		$message="Fatal error: something went wrong" ;
         $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
	}
	else if(empty($_POST['quantity'])) {
		$status="error" ;
		$message="Select quantity" ;
         $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
	}
	else if(!in_array($_POST['quantity'], $quantities)) {
		$status="error" ;
		$message="Invalid quantity" ;
         $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
	}
	else {
	    validateTrxPin($_POST['trxPin']);
	    $serviceID=filter_string($_POST['serviceID']) ;
    	$quantity=filter_string($_POST['quantity']) ;
    
    	$sql=$link->prepare("SELECT * FROM educationprices WHERE serviceid=? AND allow = 'true' ") ;
    	$sql->bind_param("s", $serviceID) ;
    	$sql->execute() ;
    	$result=$sql->get_result() ;
    	$numrow=$result->num_rows ;
    	if($numrow == 0) {
    		$status="error" ;
    		$message=$channel == "dashboard" ? "Service is temporarily unavailable" : "Service ID is incorrect";
            $data=[
                "status" => "failed",
                "channel" => $channel
            ];
            echo sendResponse($status, $message, $data);
            exit;
    	}
	
		$row=$result->fetch_assoc() ;
		$merchant=$row['merchant'] ;
		$apiServiceID=$row['apiserviceid'] ;
		$typeSingle=$row['type'] ;
		$amount=$channel == "api" ? $row['apiamount'] : $row['amount'] ;
		$amount=$role=="reseller" ? $row['reselleramount'] : $amount;

		$totalAmount=$amount * $quantity;
		//$totalAmount=productDiscount($totalAmount);
		if($totalAmount > $funds) {
			$status="error" ;
			$message="Insufficient funds " ;
            $data=[
                "status" => "failed",
                "channel" => $channel
            ];
            echo sendResponse($status, $message, $data);
			exit ;
		} 
		else{
			$sql=$link->prepare("UPDATE users SET funds=funds - ? WHERE username=?");
			$sql->bind_param("ss", $totalAmount, $username) ;
			if($sql->execute()) {
				$reference=get_rand_alphanumeric(20);
				$data=array("serviceID" => $apiServiceID, "quantity" => $quantity, "merchant" => $merchant, "reference" => $reference, "educationType" => $typeSingle) ;
				$educationalPin=educationalPin($data);
				$educationalPinStatus=$educationalPin['status'] ;
				$educationalPinMessage=$educationalPin['message'] ;
				
				$type="education" ;
				if($educationalPinStatus == "success" ) {;
					$apiReference=$educationalPin['data']['apiReference'];
					$pins=$educationalPin['data']['pins'];
					
					$status="successful" ;
					$desc="$typeSingle Pin";
					$allPins="";
					$balAF=$funds - $amount;
					$sql=$link->prepare("INSERT INTO transactions(username, serviceid, type, ownreference, apireference, amount, amountcharged, balbefore, balafter, number, description, status, message, channel, merchant, date) VALUES(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)");
                    $sql->bind_param("ssssssssssssssss", $username, $serviceID, $type, $reference, $apiReference, $amount, $amount, $funds, $balAF, $pin, $desc, $status, $educationalPinMessage, $channel, $merchant, $dateTime);
					foreach($pins as $key => $pin){
						$pin=$pins[$key]['pin'];
						$serialNo=$pins[$key]['serialNo'];
						$allPins.="<br>Pin: $pin, Serial NO: $serialNo";

						$pin=$pin."\n".$serialNo;
						$sql->execute();
					}
					$allPins=$channel=="dashboard" ? $allPins : "";
					$status="success" ;
					$message=strtoupper($typeSingle)." pin purchase successful $allPins" ;
                    $data=[
                        "type" => "education",
                        "educationType" => $typeSingle,
                        "amount" => $totalAmount,
                        "pins" => $pins,
                        "quantity" => $quantity,
                        "status" => "success",
                        "channel" => $channel
                    ];
                    echo sendResponse($status, $message, $data);
				} 
				else{
					$sql=$link->prepare("UPDATE users SET funds=funds + ? WHERE username=?");
                    $sql->bind_param("ss", $totalAmount, $username);
                    if($sql->execute()){
                        $status="error";
                        $message="Could not buy vend at this time, try again later";
                         $data=[
                            "status" => "failed",
                            "channel" => $channel
                        ];
                        $message=$educationalPinMessage;
                        echo sendResponse($status, $message, $data);
                    }
				} 
			} 
		} 
	} 
} 


if(isset($_POST['buyDataCard']) && !empty($_POST['buyDataCard'])){
    $networks=array("mtn","airtel","9mobile","glo");
    if(empty($_POST['serviceID'])){
        $status="error";
        $message="Select dataplan";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(!is_numeric($_POST['serviceID'])){
        $status="error";
        $message="Select dataplan";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(empty($_POST['quantity'])){
        $status="error";
        $message="Enter quantity";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(!is_numeric($_POST['quantity'])){
        $status="error";
        $message="Enter a valid quantity";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else{
        validateTrxPin($_POST['trxPin']);
        $serviceID=filter_string($_POST['serviceID']);
        $quantity=filter_string($_POST['quantity']);

        $sql=$link->prepare("SELECT * FROM datacardprices WHERE serviceid=? AND allow='true' ");
        $sql->bind_param("s", $serviceID);
        $sql->execute();
        $result=$sql->get_result();
        $numrow=$result->num_rows;
        $row=$result->fetch_assoc();
        if($numrow == 0){
            $status="error";
            $message=$channel == "dashboard" ? "Something went wrong validating data" : "Service ID is incorrect";
            $data=[
                "status" => "failed",
                "channel" => $channel
            ];
            echo sendResponse($status, $message, $data);
            exit;
        }
        $merchant=$row['merchant'];
        $amount=$channel=="api" ? $row['apiamount'] : $row['amount'];
        $amount=$role=="reseller" ? $row['reselleramount'] : $amount;

        $totalAmount=$amount * $quantity;
        //$totalAmount=productDiscount($totalAmount);
        $network=$row['network'];
        $dataPlan=$row['dataplan'];
        $apiServiceID=$row['apiserviceid'];
        $networkID=$row['networkid'];
        $desc=strtoupper($network)." ".$dataPlan;
        if($totalAmount > $funds){
            $status="error";
            $message="Insuffucient funds";
            $data=[
                "status" => "failed",
                "channel" => $channel
            ];
            echo sendResponse($status, $message, $data);
            exit;
        }
        
        $sql=$link->prepare("UPDATE users SET funds=funds - ? WHERE username=?");
        $sql->bind_param("ss", $totalAmount, $username);
        if($sql->execute()){
            $ownReference=get_rand_alphanumeric(20);
            $data=array("networkID" => $networkID, "reference" => $ownReference, "serviceID" => $apiServiceID, "merchant" => $merchant, "quantity" => $quantity);
            $buyDataCard=buyDataCard($data);
            $dataStatus=$dataMessage="";
            if(isset($buyDataCard['status'])){
                $dataStatus=$buyDataCard['status'];
                $dataMessage=$buyDataCard['message'];
            }

            $type="datacard";
            
            if($dataStatus == "success"){
                $status="successful";
                $apiReference=$buyDataCard['data']['apiReference'];
                $trxStatus=$buyDataCard['data']['status'];
                $pins=$buyDataCard['data']['pins']; 
                $loadPin=$buyDataCard['data']['loadPin'];
                
                $desc=strtoupper($network)." datacard";
                $allPins="";
                $balAF=$funds - $totalAmount;
                $sql=$link->prepare("INSERT INTO transactions(username, serviceid, type, ownreference, apireference, amount, amountcharged, balbefore, balafter, number, description, status, message, channel, merchant, date) VALUES(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)");
                $sql->bind_param("ssssssssssssssss", $username, $serviceID, $type, $ownReference, $apiReference, $totalAmount, $totalAmount, $funds, $balAF, $pin, $desc, $status, $dataMessage, $channel, $merchant, $dateTime);
				foreach($pins as $key => $pin){
					$pin=$pins[$key]['pin'];
					$serialNo=$pins[$key]['serialNo'];
					$allPins.="<br>Pin: $pin, Load-Pin:$loadPin";
					$pin=$pin."\n".$serialNo."\n".$loadPin;
					$sql->execute();
				}
                $allPins=$channel=="dashboard" ? $allPins : "";
                $status="success";
                $message="Data card purchase successful $allPins";
                $data=[
                    "type" => "datacard",
                    "pins" => $pins,
                    "loadPin" => $loadPin,
                    "network" => $network,
                    "dataPlan" => $dataPlan,
                    "quantity" => $quantity,
                    "amount" => $totalAmount,
                    "status" => $trxStatus,
                    "channel" => $channel
                ];
                echo sendResponse($status, $message, $data);
              
            }
            else{
                $status="failed";
                $sql=$link->prepare("UPDATE users SET funds=funds + ? WHERE username=?");
                $sql->bind_param("ss", $totalAmount, $username);
                $sql->execute();
                
                $sql=$link->prepare("UPDATE transactions SET status=?, message=? WHERE ownreference=?");
                $sql->bind_param("sss", $status, $dataMessage, $ownReference);
                $sql->execute();
                $message="Could not buy data card at this time, try again later";
                $data=[
                    "status" => $status,
                    "channel" => $channel
                ];
                $status="error";
                echo sendResponse($status, $message, $data);
            }
        }
        else{
            $status="error";
            $message="Something went wrong";
            $data=[
                "status" => "failed",
                "channel" => $channel
            ];
            echo sendResponse($status, $message, $data);
        }
    }
}


if(isset($_POST['buyAirtimePin']) && !empty($_POST['buyAirtimePin'])){
    $networks=array("mtn","airtel","9mobile","glo");
    $amounts=[100,200,500,1000];
    if(empty($_POST['serviceID'])){
        $status="error";
        $message="Select network";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(!is_numeric($_POST['serviceID'])){
        $status="error";
        $message="Select a valid network";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(empty($_POST['quantity'])){
        $status="error";
        $message="Enter quantity";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(!is_numeric($_POST['quantity'])){
        $status="error";
        $message="Enter a valid quantity";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(empty($_POST['amount'])){
        $status="error";
        $message="Enter amount";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(!is_numeric($_POST['amount'])){
        $status="error";
        $message="Enter a valid amount";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(!in_array($_POST['amount'], $amounts)){
        $status="error";
        $message="Amount can only be 100, 200, 500 or 1000";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else{
        validateTrxPin($_POST['trxPin']);
        $serviceID=filter_string($_POST['serviceID']);
        $quantity=filter_string($_POST['quantity']);
        $amount=filter_string($_POST['amount']);

        $sql=$link->prepare("SELECT * FROM airtimepinprices WHERE serviceid=? AND amount=? AND allow='true' ");
        $sql->bind_param("ss", $serviceID, $amount);
        $sql->execute();
        $result=$sql->get_result();
        $numrow=$result->num_rows;
        $row=$result->fetch_assoc();
        if($numrow == 0){
            $status="error";
            $message=$channel == "dashboard" ? "Something went wrong validating airtime pin" : "Service ID is incorrect";
            $data=[
                "status" => "failed",
                "channel" => $channel
            ];
            echo sendResponse($status, $message, $data);
            exit;
        }
        $merchant=$row['merchant'];
        $discount=$channel=="api" ? $row['apidiscount'] : $row['discount'];
        $discount=$role=="reseller" ? $row['resellerdiscount'] : $discount;
        $discountAmount=$amount - ($discount * $amount / 100);
        $totalAmount=$discountAmount * $quantity;
        $totalAmountNormal=$amount * $quantity;
        //$totalAmount=productDiscount($totalAmount);
        $network=$row['network'];
        $apiServiceID=$row['apiserviceid'];
        $desc=strtoupper($network)." pin";
        if($totalAmount > $funds){
            $status="error";
            $message="Insuffucient funds";
            $data=[
                "status" => "failed",
                "channel" => $channel
            ];
            echo sendResponse($status, $message, $data);
            exit;
        }
        
        $sql=$link->prepare("UPDATE users SET funds=funds - ? WHERE username=?");
        $sql->bind_param("ss", $totalAmount, $username);
        if($sql->execute()){
            $ownReference=get_rand_alphanumeric(20);
            $data=array("reference" => $ownReference, "serviceID" => $apiServiceID, "merchant" => $merchant, "quantity" => $quantity, "amount" => $amount);
            $buyAirtimePin=buyAirtimePin($data);
            $pinStatus=$pinMessage="";
            if(isset($buyAirtimePin['status'])){
                $pinStatus=$buyAirtimePin['status'];
                $pinMessage=$buyAirtimePin['message'];
            }

            $type="airtimepin";
            
            if($pinStatus == "success"){
                $status="successful";
                $apiReference=$buyAirtimePin['data']['apiReference'];
                $trxStatus=$buyAirtimePin['data']['status'];
                $pins=$buyAirtimePin['data']['pins'];
                $loadPin=$buyAirtimePin['data']['loadPin'];
                
                $desc=strtoupper($network)." pin";
                $allPins="";
                $balAF=$funds - $totalAmount;
                $sql=$link->prepare("INSERT INTO transactions(username, serviceid, type, ownreference, apireference, amount, amountcharged, balbefore, balafter, number, description, status, message, channel, merchant, date) VALUES(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)");
                $sql->bind_param("ssssssssssssssss", $username, $serviceID, $type, $ownReference, $apiReference, $amount, $totalAmount, $funds, $balAF, $pin, $desc, $status, $pinMessage, $channel, $merchant, $dateTime);
				foreach($pins as $key => $pin){
					$pin=$pins[$key]['pin'];
					$serialNo=$pins[$key]['serialNo'];
					$allPins.="<br>Pin: $pin, Load-pin: $loadPin";
					$pin=$pin."\n".$serialNo."\n".$loadPin;
					$sql->execute();
				}
				$allPins=$channel=="dashboard" ? $allPins : "";
                
                $status="success";
                $message="Airtime pin purchase successful $allPins";
                $data=[
                    "type" => "airtimepin",
                    "pins" => $pins,
                    "loadPin" => $loadPin,
                    "network" => $network,
                    "quantity" => $quantity,
                    "amount" => $totalAmountNormal,
                    "amountCharged" => $totalAmount,
                    "status" => $trxStatus,
                    "channel" => $channel
                ];
                echo sendResponse($status, $message, $data);
              
            }
            else{
                $status="failed";
                $sql=$link->prepare("UPDATE users SET funds=funds + ? WHERE username=?");
                $sql->bind_param("ss", $totalAmount, $username);
                $sql->execute();
                
                $sql=$link->prepare("UPDATE transactions SET status=?, message=? WHERE ownreference=?");
                $sql->bind_param("sss", $status, $pinMessage, $ownReference);
                $sql->execute();
                $message="Could not buy airtime pin at this time, try again later";
                $data=[
                    "status" => $status,
                    "channel" => $channel
                ];
                $status="error";
                // $message=$pinMessage;
                echo sendResponse($status, $message, $data);
            }
        }
        else{
            $status="error";
            $message="Something went wrong";
            $data=[
                "status" => "failed",
                "channel" => $channel
            ];
            echo sendResponse($status, $message, $data);
        }
    }
}


if(isset($_POST['bulkSms']) && !empty($_POST['bulkSms'])){
    $smsTypes=[1, 2];
    if(empty($_POST['sender'])){
        $status="error";
        $message="Enter sender name";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(empty($_POST['number'])){
        $status="error";
        $message="Enter phone number";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(empty($_POST['message'])){
        $status="error";
        $message="Enter message";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(empty($_POST['smsType'])){
        $status="error";
        $message="Enter sms type";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else if(!in_array($_POST['smsType'], $smsTypes)){
        $status="error";
        $message="Invalid sms type";
        $data=[
            "status" => "failed",
            "channel" => $channel
        ];
        echo sendResponse($status, $message, $data);
    }
    else{
        validateTrxPin($_POST['trxPin']);
        $sender=filter_string($_POST['sender']);
        $mainNumbers=filter_string($_POST['number']);
        $msgToSend=filter_string($_POST['message']);
        $pages=ceil(str_word_count($msgToSend) / 150);
        $smsType=filter_string($_POST['smsType']);

        $numbersArr=explode(" ", $mainNumbers);
        $validNumbers=['080', '090', '070', '081', '091'];
        $isValid=true;
        foreach($numbersArr as $number){
            $number=trim($number);
            if(strlen($number)!= "11"){
                $isValid=false;
                $status="error";
                $message="Number $number is not valid";
                $data=[
                    "status" => "failed",
                    "channel" => $channel
                ];
                echo sendResponse($status, $message, $data);
                break;
            }
            else if(!is_numeric($number)){
                $isValid=false;
                $status="error";
                $message="$number is not a number";
                $data=[
                    "status" => "failed",
                    "channel" => $channel
                ];
                echo sendResponse($status, $message, $data);
                break;
                exit;
            }
            else if(!in_array(substr($number, 0, 3), $validNumbers)){
                $isValid=false;
                $status="error";
                $message="$number is not a valid number";
                $data=[
                    "status" => "failed",
                    "channel" => $channel
                ];
                echo sendResponse($status, $message, $data);
                break;
                exit;
            }
        }
        if($isValid){
            $totalNumber=count($numbersArr);
            $sql=$link->prepare("SELECT * FROM bulksmsprices WHERE allow='true' ");
            $sql->execute();
            $result=$sql->get_result();
            $numrow=$result->num_rows;
            $row=$result->fetch_assoc();
            if($numrow == 0){
                $status="error";
                $message="Service is not avaliable";
                $data=[
                    "status" => "failed",
                    "channel" => $channel
                ];
                echo sendResponse($status, $message, $data);
                exit;
            }
            $merchant=$row['merchant'];
            $amount=$channel=="api" ? $row['apiamount'] : $row['amount'];
            $amount=$role=="reseller" ? $row['reselleramount'] : $amount;
            $amount=$amount * $pages;

            $allNumbers=str_replace(",", " ", $mainNumbers);
            $totalAmount=$amount * $totalNumber;
            $totalAmountNormal=$amount * $totalNumber;
            //$totalAmount=productDiscount($totalAmount);
            
            if($totalAmount > $funds){
                $status="error";
                $message="Insuffucient funds";
                $data=[
                    "status" => "failed",
                    "channel" => $channel
                ];
                echo sendResponse($status, $message, $data);
                exit;
            }
            
            $sql=$link->prepare("UPDATE users SET funds=funds - ? WHERE username=?");
            $sql->bind_param("ss", $totalAmount, $username);
            if($sql->execute()){
                $ownReference=get_rand_alphanumeric(20);
                $data=array("sender" => $sender, "message" => $msgToSend, "numbers" => $allNumbers, "merchant" => $merchant, "smsType" => $smsType);
                $bulkSms=bulkSms($data);
                $smsStatus=$smsMessage="success";
                if(isset($bulkSms['status'])){
                    $smsStatus=$bulkSms['status'];
                    $smsMessage=$bulkSms['message'];
                }
    
                $type="bulksms";
                
                if($smsStatus == "success"){
                    $status="successful";
                    $trxStatus=$bulkSms['data']['status'];
                    $totalWrongNumber=$bulkSms['data']['totalWrongNumber'];
                    $totalCorrectNumber=$bulkSms['data']['totalCorrectNumber'];

                    $desc="Bulk SMS";
                    $balAF=$funds - $totalAmount;
                    $sql=$link->prepare("INSERT INTO transactions(username, serviceid, type, ownreference, apireference, amount, amountcharged, balbefore, balafter, number, description, status, message, channel, merchant, date) VALUES(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)");
                    $sql->bind_param("ssssssssssssssss", $username, $serviceID, $type, $ownReference, $ownReference, $amount, $totalAmount, $funds, $balAF, $allNumbers, $desc, $status, $smsMessage, $channel, $merchant, $dateTime);
    			    $sql->execute();
    				$sql=$link->prepare("INSERT INTO bulksms(username, amount, smstype, totalnumber, totalcorrectnumber, totalwrongnumber, reference, sender, message, page, date) VALUES(?,?,?,?,?,?,?,?,?,?,?)");
    				$sql->bind_param("sssssssssss", $username, $totalAmount, $smsType, $mainNumbers, $totalCorrectNumber, $totalWrongNumber, $ownReference, $sender, $msgToSend, $pages, $dateTime);
    				$sql->execute();
                    
                    $status="success";
                    $message="Bulk SMS sent successfully";
                    $data=[
                        "type" => "bulksms",
                        "totalCorrectNumber" => $totalCorrectNumber,
                        "totalWrongNumber" => $totalWrongNumber,
                        "status" => $trxStatus,
                        "channel" => $channel
                    ];
                    echo sendResponse($status, $message, $data);
                  
                }
                else{
                    $status="failed";
                    $sql=$link->prepare("UPDATE users SET funds=funds + ? WHERE username=?");
                    $sql->bind_param("ss", $totalAmount, $username);
                    $sql->execute();
                    
                    $sql=$link->prepare("UPDATE transactions SET status=?, message=? WHERE ownreference=?");
                    $sql->bind_param("sss", $status, $smsMessage, $ownReference);
                    $sql->execute();
                    $message="Could not send bulk sms at this time, try again later";
                    $data=[
                        "status" => $status,
                        "channel" => $channel
                    ];
                    $status="error";
                    $message=$smsMessage;
                    echo sendResponse($status, $message, $data);
                }
            }
            else{
                $status="error";
                $message="Something went wrong";
                $data=[
                    "status" => "failed",
                    "channel" => $channel
                ];
                echo sendResponse($status, $message, $data);
            }
        }
    }
}

function productDiscount($amount){
    global $productDiscount, $role; 
    
    // return ($acctType == "standard") ? $amount - ($productDiscount * $amount / 100) : $amount; 
    return $amount;
}
?>
