<?php
$genMsg="";
$convertionRate="0.2";
if(isset($_POST['withdraw'])){
    

    $wallets=array("main", "referral");
    if(empty($_POST['amount'])){
        $status="error";
        $message="Enter an amount to withdraw";
        $genMsg=sendResponse($status, $message);
    }
    else if(!is_numeric($_POST['amount'])){
        $status="error";
        $message="Invalid amount";
        $genMsg=sendResponse($status, $message);
    }
    else if($_POST['amount'] > $referralFunds){
        $status="error";
        $message="Insufficient referral balance";
        $genMsg=sendResponse($status, $message);
    }
    else{
        $wallet="referral";
        $amount=filter_string($_POST['amount']);
        if($wallet == "main" && ($amount < $minMainWithdrawAmt)){
            $status="error";
            $message="Minimum main wallet withdrawal is NGN $minMainWithdrawAmt";
            $genMsg=sendResponse($status, $message);
        }
        else if($wallet == "referral" && ($amount < $minRefWithdrawAmt)){
            $status="error";
            $message="Minimum referral withdrawal is NGN $minRefWithdrawAmt";
            $genMsg=sendResponse($status, $message);
        }
        else if($wallet == "main" && ($amount > $funds)){
            $status="error";
            $message="Insufficent funds on your main wallet";
            $genMsg=sendResponse($status, $message);
        }
        else if($wallet == "referral" && ($amount > $referralFunds)){
            $status="error";
            $message="Insufficent funds on your referral wallet";
            $genMsg=sendResponse($status, $message);
        }
        else if($_POST['wallet'] == "main" && !$mainWithdraw){
            $status="error";
            $message="Main wallet withdrawal is currently not avaliable";
            $genMsg=sendResponse($status, $message);
        }
        else if($_POST['wallet'] == "referral" && !$refWithdraw){
            $status="error";
            $message="Referral withdrawal is currently not avaliable";
            $genMsg=sendResponse($status, $message);
        }
        else{
            $sql=$link->prepare("SELECT * FROM withdrawals WHERE username=? AND status='pending' ");
            $sql->bind_param("s", $username);
            $sql->execute();
            $result=$sql->get_result();
            $numrow_link=$result->num_rows;

            $sql=$link->prepare("SELECT * FROM bankaccounts WHERE username=?");
            $sql->bind_param("s", $username);
            $sql->execute();
            $result=$sql->get_result();
            $numrow_bnAcct=$result->num_rows;

            if($numrow_bnAcct == 0){
                $status="error";
                $message="You have not set up any bank account. Update your profile to withdraw";
                $genMsg=sendResponse($status, $message);
            }
            else if($numrow_link > 0){
                $status="error";
                $message="You have a pending withdrawal already";
                $genMsg=sendResponse($status, $message);
            }
            else{
                $sql=$link->prepare("INSERT INTO withdrawals(username, wallet, amount, description, number, date) VALUES(?,?,?,?,?,?)");
                $sql->bind_param("ssssss", $username, $wallet, $amount, $acctName, $acctNum, $dateTime);
                if($sql->execute()){
                    if($wallet == "main"){
                        $sql=$link->prepare("UPDATE users SET funds=funds - ? WHERE username=?");
                    }
                    else{
                        $sql=$link->prepare("UPDATE users SET referralfunds=referralfunds - ? WHERE username=?");
                    }
                    $sql->bind_param("ss", $amount, $username);
                    $sql->execute();

                    $sql=$link->prepare("SELECT * FROM users WHERE username=?");
                    $sql->bind_param("s", $username);
                    $sql->execute();
                    $result=$sql->get_result();
                    $row=$result->fetch_assoc();
                    $funds=$row['funds'];
                    $referralFunds=$row['referralfunds'];

                    $status="success";
                    $amount=number_format($amount, 2);
                    $message="NGN$amount successfully withdrawn from $wallet wallet";
                    $genMsg=sendResponse($status, $message);

                }
                else{
                    $status="error";
                    $message="Something went wrong"; 
                    $genMsg=sendResponse($status, $message);
                }
            }
        }
    }
}



if(isset($_POST['convertReferral'])){
    if(empty($_POST['amount'])){
        $status="error";
        $message="Enter an amount to transfer";
        $genMsg=sendResponse($status, $message);
    }
    else if(!is_numeric($_POST['amount'])){
        $status="error";
        $message="Invalid amount";
        $genMsg=sendResponse($status, $message);
    }
    else if($_POST['amount'] > $referralFunds){
        $status="error";
        $message="Insufficient referral balance";
        $genMsg=sendResponse($status, $message);
    }
    else{
        $amount=filter_string($_POST['amount']);

        $sql=$link->prepare("UPDATE users SET referralfunds=referralfunds-?, funds=funds + ? WHERE username=?");
        $sql->bind_param("sss", $amount, $amount, $username);
        if($sql->execute()){
            $mainFunds += $amount;
            $referralFunds += $amount;
            $status="success";
            $message="₦$amount Referral earnings transferred to main balance";
            $genMsg=sendResponse($status, $message);
        }
        else{
            $status="error";
            $message="Something went wrong";
            $genMsg=sendResponse($status, $message);
        }
    }
}

if(isset($_POST['convertActivity'])){
    if(empty($_POST['amount'])){
        $status="error";
        $message="Enter an amount to convert";
        $genMsg=sendResponse($status, $message);
    }
    else if(!is_numeric($_POST['amount'])){
        $status="error";
        $message="Invalid amount";
        $genMsg=sendResponse($status, $message);
    }
    else if($_POST['amount'] > $ellenPoints){
        $status="error";
        $message="Insufficient eLLenPoints";
        $genMsg=sendResponse($status, $message);
    }
    else{
        $amount=filter_string($_POST['amount']);
        $amt=$amount * $convertionRate;
        
        $sql=$link->prepare("UPDATE users SET ellenpoints=ellenpoints-?, funds=funds + ? WHERE username=?");
        $sql->bind_param("sss", $amount, $amt, $username);
        if($sql->execute()){
            $mainFunds += $amt;
            $funds -= $amount;
            $status="success";
            $message="$amount ellenPoints earnings converted to main balance";
            $genMsg=sendResponse($status, $message);
        }
        else{
            $status="error";
            $message="Something went wrong";
            $genMsg=sendResponse($status, $message);
        }
    }
}

?>