<?php
require $_SERVER['DOCUMENT_ROOT']."/stream.php";
require $_SERVER['DOCUMENT_ROOT']."$stream/includes/generalinclude.php";
require $_SERVER['DOCUMENT_ROOT']."$stream/app/includes/generalinclude.php";

$title ="Cable Subscription";  
include"inc/header.php"; 
?>

          <!-- Breadcrumb Area -->
            <div class="breadcrumb-area">
                <h1><?php echo $title?></h1>

                <ol class="breadcrumb">
                    <li class="item"><a href="index.php"><i class='bx bx-home-alt'></i></a></li>
                    <li class="item">Dashboard</li>

                    <li class="item"><?php echo $title?></li>
                </ol>
            </div>
            <!-- End Breadcrumb Area -->
            
           
            <!-- Start -->
            <div class="card mb-30">
                <div class="card-header d-flex justify-content-between align-items-center">
                    <h3><?php echo $title?></h3>

                
                </div>

                <div class="card-body">
                    <form>
                        <div class="form-group">
                            <label>Select Type</label>
                              <select id="type" name="plan" class="form-control cable">
                                                            <option value="" selected disabled>Select cable</option>

                                                            <option value="gotv">GOTV</option>
                                                            <option value="dstv">DSTV</option>
                                                            <option value="startimes">STARTIME</option>


                                                            </select>
                        </div>
                        <div class="form-group">
                            <label>Select Plan</label>
                              <select id="plan" class="form-control serviceID">
                                                    <option value="" selected disabled>Select Plan</option>
                                                </select>
                        </div>
                        <div class="form-group">
                            <label>Enter Correct IUC/PIN Number</label>
                            <input type="number" class="form-control iucNum" placeholder="eg: 44066778800">
                        </div>
                        <button type="submit" class="btn btn-primary proceed">Validate Details</button>
                    </form>

                    
                    
                </div>
            </div>
             <div class="response"></div>
            <!-- Start -->
            <div class="row">
                <div class="col-lg-12 col-md-12">
                    <div class="card recent-orders-box mb-30">
                        <div class="card-header d-flex justify-content-between align-items-center">
                            <h3>Recent Transactions</h3>

                            <div class="dropdown">
            <button class="dropdown-toggle" type="button" data-toggle="dropdown" aria-haspopup="true"
                aria-expanded="false">
                <i class='bx bx-dots-horizontal-rounded'></i>
            </button>
            <div class="dropdown-menu">
                <a class="dropdown-item d-flex align-items-center" href="transactions">
                    <i class='bx bx-show'></i> View All
                </a>
            </div>
        </div>
                        </div>

                        <div class="card-body">
                            <div class="table-responsive">
                                <table class="table">
                                    <thead>
                                        <tr>
                                            <th>Trx Id</th>
                                            
                                            <th>Desc</th>
                                            <th>IUC Number</th>
                                            <th>Amount</th>
                                            <th>Transaction Date</th>
                                            <th>Status</th>
                                            <th>Receipt</th>
                                        </tr>
                                    </thead>

                                    <tbody>
                                       <?php
                                $sql=$link->prepare("SELECT * FROM transactions WHERE username=? AND type='cable' ORDER BY id DESC LIMIT 5");
                                $sql->bind_param("s", $username);
                                $sql->execute();
                                $result=$sql->get_result();
                                $numrow=$result->num_rows;
                                if($numrow > 0){
                                    while($row=$result->fetch_assoc()){
                                        $id=$row['id'];
                                        $desc=$row['description'];
                                        $date=$row['date'];
                                        $amount=$row['amount'];
                                        $iucNum=$row['number'];
                                        $status=$row['status'];
                                        if($status =="success" || $status =="successful"){
                                                $statusColor="success";
                                            }
                                            else if($status =="pending"){
                                                $statusColor="warning";
                                            }
                                            else{
                                                $statusColor="danger";
                                            }
                                ?>
                                        <tr>
                                            <td><?php echo $id?></td>
                                            <td class="name"> <?php echo $desc?></td>
                                            <td class="name"> <?php echo $iucNum?></td>
                                            <td class="text-danger">- ₦<?php echo number_format($amount, 2)?></td>
                                            <td><?php echo $date?></td>
                                            <td class=" text-<?php echo $statusColor ?>"><?php echo $status?></td>
                                            <td><a href="receipt?id=<?php echo $id?>" class="btn btn-sm btn-primary text-white">Receipt</a></td>
                                        </tr>
                                        <?php }} ?>
                                    </tbody>
                                </table>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            
<script>
        $("form").on("submit", function(){
             return false;
        })
        $(".cable").on("change", function(){
        let cable=$(this).val();
            $.ajax({
                url: "actions/cableplans",
                type: "POST",
                data: {
                    cablePlan : "cablePlan",
                    cable : cable,
                },
                beforeSend:function(){
                    $(".serviceID").html("<option value='' selected disabled>Loading...</option>");
                },
                success:function(data){
                    $(".serviceID").html(data);
                }
            })

        })
        function proceedTrx(trxPin){
            let cable=$(".cable").val();
            let iucNum=$(".iucNum").val();
            let serviceID=$(".serviceID").val();
            let cablePlan=$(".serviceID option:selected").text();
            let $this=$(".proceed");
            let title,message,icon;
            if(cable == "" || cable == null){
                title="ERROR";
                icon="error";
                message="Select your cable";
                popup(title, message, icon, false);
            }
            else if(serviceID == "" || serviceID == null){
                title="ERROR";
                icon="error";
                message="Select data plan";
                popup(title, message, icon, false);
            }
            else if(iucNum == ""){
                title="ERROR";
                icon="error";
                message="Enter your IUC number";
                popup(title, message, icon, false);
            }
            else if(isNaN(iucNum)){
                title="ERROR";
                icon="error";
                message="Enter a valid IUC number";
                popup(title, message, icon, false);
            }
            else{
                title="WARNING";
                icon="info";
                message="You are about to subscribe to Cable: " + cable +" Cable type: "+ cablePlan  + " IUC Num: " + iucNum + " Do you want to proceed?";
                popup(title, message, icon, true, $this);
            }


            function popup(title, message, icon, confirm, $this){
                Swal.fire({
                    title: '<strong>'+ title +'</strong>',
                    icon: icon,
                    html: message,
                    showDenyButton: true,
                    confirmButtonText: 'Proceed',
                    denyButtonText: 'Cancel',
                })
                .then((result) => {
                    if(result.isConfirmed && confirm){

                        $.ajax({
                            url: "actions/topup",
                            type: "POST",
                            data: {
                                validateCable : "validateCable",
                                cable : cable,
                                iucNum : iucNum,
                                serviceID : serviceID,
                            },
                            beforeSend:function(){
                                $($this).html("Processing...")
                                $($this).attr("disabled", true);
                            },
                            success:function(response){
                                $($this).html("<em class='icon ni ni-arrow-right'></em><span> Procced</span>")
                                $($this).attr("disabled", false);
                                try{
                                    var resp=JSON.parse(response);
                                    let status=resp.status;
                                    if(status == "success"){
                                        let customerName=resp.data.customerName;
                                        let title="Confirm Details";
                                        let message="Customer name: <strong>" + customerName;
                                        let icon="info";
                                        let confirm=true;
                                        validatePopUp(title, message, icon, confirm, $this);
                                    }
                                    else{
                                        let title="Cable validation failed";
                                        let message="";
                                        let icon="error";
                                        let confirm=false;
                                        validatePopUp(title, message, icon, confirm, $this);                                    }
                                }
                                catch(e){
                                    $(".response").html(response);
                                }
                            }
                        })
                    }
                })
            }

            function validatePopUp(title, message, icon, confirm, $this){
                Swal.fire({
                    title: '<strong>'+ title +'</strong>',
                    icon: icon,
                    html: message,
                    showDenyButton: true,
                    confirmButtonText: 'Proceed',
                    denyButtonText: 'Cancel',
                })
                .then((result) => {
                    if(result.isConfirmed && confirm){

                        $.ajax({
                            url: "actions/topup",
                            type: "POST",
                            data: {
                                subCable : "subCable",
                                serviceID : serviceID,
                                cable : cable,
                                iucNum : iucNum,
                                trxPin : trxPin

                            },
                            beforeSend:function(){
                                $($this).html("Processing...")
                                $($this).attr("disabled", true);
                            },
                            success:function(data){
                                $($this).html("<em class='icon ni ni-arrow-right'></em><span> Procced</span>")
                                $($this).attr("disabled", false);
                                try{
                                    let response=JSON.parse(data);
                                    let message=response.message;
                                    let isPin=response.data.isPin;
                                    let isPinR=response.data.isPinR;
                                    if(isPin){
                                        Swal.fire({
                                            title: '<strong>' + message + '</strong>',
                                            icon: icon,
                                            html: '',
                                            showDenyButton: false,
                                            confirmButtonText: 'Ok',
                                        })
                                        .then((result) => {
                                            if(result.isConfirmed && isPinR){
                                                location.href="settings";
                                            }
                                        })
                                    }
                                }
                                catch(e){
                                    $(".response").html(data);
                                }
                            }
                        })
                    }
                })
            }
        } 
        $(".proceed").on("click", function(){
             Swal.fire({
                title: 'Enter pin',
                icon: 'info',
                html: '',
                showCancelButton: false,
                confirmButtonText: 'Proceed',
                input: 'text'
            })
            .then((result) => {
                if(result.isConfirmed){
                    proceedTrx(result.value);
                }
            })
        })
        </script>

            <?php include"inc/footer.php" ; ?>