<?php
function reserveMonnifyAccount($data){
    global $mfyContractCode;
    $accountName=$data['accountName'];
    $accountReference=$data['accountReference'];
    $customerEmail=$data['customerEmail'];
    $customerName=$data['customerName'];
    $token=$data['token'];

    $url="https://api.monnify.com/api/v2/bank-transfer/reserved-accounts";
    $method="POST";
    $headers=array("Authorization: Bearer $token", "Content-Type:application/json");
    $postFields=json_encode(array(
        "accountReference" => $accountReference,
        "accountName" => $accountName,
        "currencyCode" => "NGN",
        "contractCode" => $mfyContractCode,
        "customerEmail" => $customerEmail,
        "bvn" => "21212121212",
        "customerName" => $customerName,
        "getAllAvailableBanks" => true
    ));
    $data=array("url" => $url, "method" => $method, "headers" => $headers, "postFields" => $postFields);

    $curlRequest=curlRequest($data);
    $curlStatus=$curlRequest['requestSuccessful'];
    $curlMessage=$curlRequest['responseMessage'];
    $curlMessage=$curlRequest['responseMessage'];
    if($curlStatus){
        $status="success";
        $message="Accounts created";
        $accounts=$curlRequest['responseBody']['accounts'];
        $reservationReference=$curlRequest['responseBody']['reservationReference'];
        $data=array("accounts" => $accounts, "reservationReference" => $reservationReference);
    }
    else{
        $status="error";
        $message=$curlMessage;
        $data=array();
    }
    return $response=array("status" => $status, "message" => $message, "data" => $data);
}

function getMonnifyToken(){
    global $mfyApiKey, $mfySecKey;
    $url="https://api.monnify.com/api/v1/auth/login";
    $method="POST";
    $headers=array("Authorization: Basic ". base64_encode("$mfyApiKey:$mfySecKey"));
    $postFields=json_encode(array());
    $data=array("url" => $url, "method" => $method, "headers" => $headers, "postFields" => $postFields);

    $curlRequest=curlRequest($data);
    $curlStatus=$curlRequest['requestSuccessful'];
    $curlMessage=$curlRequest['responseMessage'];
    $curlMessage=$curlRequest['responseMessage'];
    if($curlStatus){
        $status="success";
        $message="Token fetched successfully";
        $token=$curlRequest['responseBody']['accessToken'];
        $data=array("token" => $token);
    }
    else{
        $status="error";
        $message=$curlMessage;
        $data=array();
    }
    return $response=array("status" => $status, "message" => $message, "data" => $data);
}


function verifyMonnifyTrx($reference, $deductCharge=true){
    global $link, $dateTime, $paymentTransferFee;
    $username="null";
    $getMonnifyToken=getMonnifyToken();
    $data=['username' => ''];
    $body=json_encode($getMonnifyToken);
    // $type="monnifyWebHookToken";
    // $sql=$link->prepare("INSERT INTO webhooks(response, reference, type, username, date) VALUES(?,?,?,?,?)");
    // $sql->bind_param("sssss", $body, $reference, $type, $username, $dateTime);
    // $sql->execute();
        
    $status=$getMonnifyToken['status'];
    if($status == "success"){
        $token=$getMonnifyToken['data']['token'];
        $url="https://api.monnify.com/api/v2/transactions/".urlencode($reference);
        $method="GET";
        $headers=array("Authorization: Bearer $token");
        $postFields=json_encode(array());
        $requestData=array("url" => $url, "method" => $method, "headers" => $headers, "postFields" => $postFields);

        $curlRequest=curlRequest($requestData);
        
        // $body=json_encode($curlRequest);
        // $type="monnifyWebHookCurl";
        // $sql=$link->prepare("INSERT INTO webhooks(response, reference, type, username, date) VALUES(?,?,?,?,?)");
        // $sql->bind_param("sssss", $body, $reference, $type, $username, $dateTime);
        // $sql->execute();
        
        $curlStatus=$curlRequest['requestSuccessful'];
        $curlMessage=$curlRequest['responseMessage'];
        
        if($curlStatus){
            $paymentStatus=strtolower($curlRequest['responseBody']['paymentStatus']);
            $amountPaid=$curlRequest['responseBody']['amountPaid'];
            $paymentMethod=$curlRequest['responseBody']['paymentMethod'];
            $email=$curlRequest['responseBody']['customer']['email'];
            $sql=$link->prepare("SELECT * FROM users WHERE email=?");
            $sql->bind_param("s", $email);
            $sql->execute();
            $result=$sql->get_result();
            $numrow=$result->num_rows;
            $row=$result->fetch_assoc();

            
            $sql=$link->prepare("SELECT * FROM fundwallet WHERE trxid=?");
            $sql->bind_param("s", $reference);
            $sql->execute();
            $result=$sql->get_result();
            $numrow_reference=$result->num_rows;
            
            if($numrow == 1 && $numrow_reference == 0 && $paymentStatus == "paid"){
                $currency="NGN";
                $code=get_rand_alphanumeric(15);
                $iniFrom="monnify";
                $username=$row['username'];
                $data['username']=$username;
                $balBefore=$row['funds'];
                if($amountPaid >= 0){
                    $deductedAmt=$amountPaid - ($amountPaid * $paymentTransferFee / 100) ;
                    $balAfter=$balBefore + $deductedAmt;

                    $paymentStatus="successful";
                    $sql=$link->prepare("UPDATE users SET funds=funds + ? WHERE email=?");
                    $sql->bind_param("ss", $deductedAmt, $email);
                    $sql->execute();
                    
                    $sql=$link->prepare("INSERT INTO fundwallet(code, username, email, amount, channel, status, trxid, initiatedfrom, message, currency, balancebefore, balanceafter, date) VALUES(?,?,?,?,?,?,?,?,?,?,?,?,?)");
                    $sql->bind_param("sssssssssssss", $code, $username, $email, $deductedAmt, $paymentMethod, $paymentStatus, $reference, $iniFrom, $curlMessage, $currency, $balBefore, $balAfter, $dateTime);
                    $sql->execute();
                    
                    
                    $sql=$link->prepare("SELECT * FROM referrals WHERE username=?");
                    $sql->bind_param("s", $username);
                    $sql->execute();
                    $result=$sql->get_result();
                    $numrow_refUser=$result->num_rows;
                    if($numrow_refUser == 1){
                        $row=$result->fetch_assoc();
                        $refUsername=$row['referral'];
        
                        $sql=$link->prepare("SELECT * FROM users WHERE username=?");
                        $sql->bind_param("s", $refUsername);
                        $sql->execute();
                        $result=$sql->get_result();
                        $numrow_refUser=$result->num_rows;
                        $row=$result->fetch_assoc();
                        $refVerifiedRef=$row['verified'];
                        $refAcctTypeRef=$row['acctype'];
                        
                        $sql=$link->prepare("SELECT * FROM users WHERE username=?");
                        $sql->bind_param("s", $username);
                        $sql->execute();
                        $result=$sql->get_result();
                        $numrow_refUser=$result->num_rows;
                        $row=$result->fetch_assoc();
                        $refVerifiedUser=$row['verified'];
                        $refAcctTypeUser=$row['acctype'];
                        
                        $sql=$link->prepare("SELECT SUM(amount) AS totalFunding FROM fundwallet WHERE username=?");
                        $sql->bind_param("s", $refUsername);
                        $sql->execute();
                        $result=$sql->get_result();
                        $numrow_fundingRef=$result->num_rows;
                        $rowRef=$result->fetch_assoc();
                        
                        $sql=$link->prepare("SELECT SUM(amount) AS totalFunding FROM fundwallet WHERE username=?");
                        $sql->bind_param("s", $username);
                        $sql->execute();
                        $result=$sql->get_result();
                        $numrow_fundingUser=$result->num_rows;
                        $rowUser=$result->fetch_assoc();
                        
                        if($numrow_fundingRef > 0){
                            $totalFundingRef=$rowRef['totalFunding'];
                            $totalFundingUser=$rowUser['totalFunding'];
                            if($refAcctTypeUser == "free"){
                                if($totalFundingRef >= 500 && $totalFundingUser >= 500 && $refVerifiedUser && $refVerifiedRef){
                                    $refBonus=0;
                                    $sql=$link->prepare("UPDATE users SET referralfunds=referralfunds + ? WHERE username=?");
                                    $sql->bind_param("ss", $refBonus, $refUsername);
                                    $sql->execute();
                                    
                                    $sql=$link->prepare("UPDATE referrals SET earnings=? WHERE reference=?");
                             	    $sql->bind_param("ss", $refBonus, $reference);
                          	        $sql->execute();
                                }
                            }
                            else{
                                $sql=$link->prepare("UPDATE referrals SET earnings=? WHERE reference=?");
                                $sql->bind_param("ss", $refBonus, $reference);
                                $sql->execute();
                                
                                $sql=$link->prepare("UPDATE users SET referralfunds=referralfunds + ? WHERE username=?");
                                $sql->bind_param("ss", $refBonus, $refUsername);
                                $sql->execute();
                            }
                        }
                    }
                    $status="success";
                    $message="Wallet has been funded";
                }
                else{
                    $status="error";
                    $message="Amount is less than N0";
                }
            }
            else{
                $status="success";
                $message="Wallet funded successfully";
            }
        }
        else{
            $status="error";
            $message="Something went wrong";
        }
    }
    $response=[
        "status" => $status,
        "message" => $message,
        "data" => $data
    ];
    return $response;
}
?>
