<?php
function buyAirtime($data) {
    global $gladTidingsApiKey, $ncWalletApiKey, $uzobestApiKey, $inlomaxApiKey, $gwanyoApiKey;
	$phone=$data['phone'];
	$serviceID=$data['serviceID'];
	$amount=$data['amount'] ;
	$reference=$data['reference'];
	$merchant=$data['merchant'];

    $method="POST";
    $isGladTidings=$isNcWallet=$isUzobest=$isInlomax=$isGwanyo=false;
    if($merchant == "gladtidings"){
        $isGladTidings=true;
        $headers=[
    	   "Authorization: Token $gladTidingsApiKey",
    	];
        $postFields=[
            "network" => $serviceID, 
            "amount" => $amount, 
            "mobile_number" => $phone, 
            "Ported_number" => true,
            "airtime_type" => "VTU"
        ];
	    $url="https://www.gladtidingsdata.com/api/topup/";
    }
    else if($merchant == "ncwallet"){
        $isNcWallet=true;
        $headers=[
    	   "Authorization: $ncWalletApiKey",
    	];
        $postFields=json_encode([
            "network" => $serviceID, 
            "amount" => $amount, 
            "phone" => $phone, 
            "plan_type" => "VTU",
            "bypass" => true,
            "request-id" => $reference
        ]);
	    $url="https://ncwallet.ng/api/topup/";
    }
    else if($merchant == "gwanyo"){
        $isGwanyo=true;
        $headers=[
    	   "Authorization-Token: $gwanyoApiKey",
    	];
        $postFields=json_encode([
            "serviceID" => $serviceID, 
            "amount" => $amount, 
            "phoneNumber" => $phone, 
            "clientReference" => $reference
        ]);
	    $url="https://gwanyoconnect.com.ng/api/airtime.php";
    }
	else if($merchant == "uzobest"){
        $isUzobest=true;
        $headers=[
     	    "Authorization: $uzobestApiKey",
    	];
       $postFields = [
    "network_id" => $serviceID,
    "amount" => $amount,
    "phone_number" => $phone,
    "ported" => true,
    "airtime_type" => "VTU"
];
	    $url="https://uzobestgsm.ng/api/v1/purchase_airtime";
    }
	else if($merchant == "inlomax"){
        $isInlomax=true;
        $headers=[
    	   "Authorization: Token $inlomaxApiKey",
    	];
        $postFields=json_encode([
            "serviceID" => $serviceID,           
            "amount" => $amount, 
            "mobileNumber" => $phone          
        ]);
	    $url="https://inlomax.com/api/airtime";
    }
	
	$payLoad=[
	    "url" => $url,
	    "method" => $method,
	    "postFields" => $postFields,
	    "headers" => $headers
	 ];

	$response=curlRequest($payLoad); 
	$data=[];
	if($isGladTidings){
	    if(isset($response['Status'])){
	        $trxStatus=$response['Status'];
	        if($trxStatus == "successful"){
    	        $status="success";
    	        $message="Transaction was successful";
    	        $reference=$response['id'];
    	        $amount=$response['paid_amount'];
    	        $data['apiReference']=$reference;
    	        $data['amount']=$amount;
    	        $data['status']=$status;
    	    }
    	    else{
    	        $status="error";
    	        $message="Transaction Failed";
    	        $data['status']="failed";
    	    }
	    }
	    else{
	        $status="error";
	        $message=$response['error'];
	        $data['status']="failed";
	    }
	    
	}
	else if($isNcWallet){
        if(isset($response['status'])){
	        $trxStatus=$response['status'];
            if($trxStatus == "success"){
    	        $status="success";
    	        $message="Transaction was successful";
    	        $reference=$response['request-id'];
    	        $amount=$response['amount'];
    	        $data['apiReference']=$reference;
    	        $data['amount']=$amount;
    	        $data['status']=$status;
    	    }
    	    else{
    	        $trxStatus="failed";
    	        $status="error";
    	        $message=$response['msg'];
    	        $data['status']=$trxStatus;
    	    }
        }
        else{
	        $status="error";
	        $message="Something went wrong with transaction";
	        $data['status']="failed";
	    }
	}
	else if($isGwanyo){
        if(isset($response['status'])){
	        $trxStatus=$response['status'];
            if($trxStatus == "success"){
    	        $status="success";
    	        $message="Transaction was successful";
    	        $reference=$response['data']['clientReference'];
    	        $amount=$response['data']['amount'];
    	        $data['apiReference']=$reference;
    	        $data['amount']=$amount;
    	        $data['status']=$status;
    	    }
    	    else{
    	        $trxStatus="failed";
    	        $status="error";
    	        $message=$response['message'];
    	        $data['status']=$trxStatus;
    	    }
        }
        else{
	        $status="error";
	        $message="Something went wrong with transaction";
	        $data['status']="failed";
	    }
	}

	else if($isUzobest){
	    if(isset($response['status'])){
	        $trxStatus=$response['status'];
	        if($trxStatus == "successful"){
    	        $status="success";
    	        $message=$response['message'];
    	        $reference=$response['transaction_id'];
    	        $amount=$response['transaction_id'];
    	        $data['apiReference']=$reference;
    	        $data['amount']=$amount;
    	        $data['status']=$status;
    	    }
			else{
			$trxStatus="failed";
			$status="error";
			$message=$response['message'];
			$data['status']=$trxStatus;
		}
	}
	else{
		$status="error";
		$message=$response['message'];
		$data['status']="failed";
	    }
	    
	}
	else if($isInlomax){
        if(isset($response['status'])){
	        $trxStatus=$response['status'];
            if($trxStatus == "success"){
    	        $status="success";
    	        $message="Transaction was successful";
    	        $reference=$response['data']['reference'];
    	        $amount=$response['data']['amount'];
    	        $data['apiReference']=$reference;
    	        $data['amount']=$amount;
    	        $data['status']=$status;
    	    }
    	    else{
    	        $trxStatus="failed";
    	        $status="error";
    	        $message=$response['message'];
    	        $data['status']=$trxStatus;
    	    }
        }
        else{
	        $status="error";
	        $message="Something went wrong with transaction";
	        $data['status']="failed";
	    }
	}

	$response=[
	    "status" => $status,
	    "message" => $message,
	    "data" => $data
	];
	
	return $response;
}


function buyData($data) {
    global $gladTidingsApiKey, $ncWalletApiKey, $uzobestApiKey, $inlomaxApiKey, $gwanyoApiKey;
	$phone=$data['phone'];
	$serviceID=$data['serviceID'];
	$networkID=$data['networkID'];
	$reference=$data['reference'];
	$merchant=$data['merchant'];
	$type="data";


	$method="POST";
    $isGladTidings=$isNcWallet=$isUzobest=$isInlomax=$isGwanyo=false;
    if($merchant == "gladtidings"){
        $isGladTidings=true;
        $token=$gladTidingsApiKey;
        $headers=[
    	   "Authorization: Token $token",
    	];
        $postFields=[
            "network" => $networkID,  
            "mobile_number" => $phone, 
            "plan" => $serviceID, 
            "Ported_number" => true,
        ];
	    $url="https://www.gladtidingsdata.com/api/data/";
    }
    else if($merchant == "ncwallet"){
        $isNcWallet=true;
        $token=$ncWalletApiKey;
        $headers=[
    	   "Authorization: $token",
    	];
        $postFields=json_encode([
            "network" => $networkID, 
            "phone" => $phone, 
            "data_plan" => $serviceID,
            "bypass" => true,
            "request-id" => $reference
        ]);
	    $url="https://ncwallet.ng/api/data/";
    }
     else if($merchant == "gwanyo"){
        $isGwanyo=true;
        $headers=[
    	   "Authorization-Token: $gwanyoApiKey",
    	];
        $postFields=json_encode([
            "serviceID" => $serviceID, 
            "phoneNumber" => $phone, 
            "clientReference" => $reference
        ]);
	    $url="https://gwanyoconnect.com.ng/api/data.php";
    }
	else if($merchant == "uzobest"){
        $isUzobest=true;
        $headers=[
    	   "Authorization: $uzobestApiKey",
    	];
		$postFields=[
            "network_id" => $networkID,  
            "phone_number" => $phone, 
            "plan_id" => $serviceID, 
            "ported" => true,
        ];
	    $url="https://uzobestgsm.ng/api/v1/purchase_data";
    }
	else if($merchant == "inlomax"){
        $isInlomax=true;
        $headers=[
    	   "Authorization: Token $inlomaxApiKey",
    	];
        $postFields=json_encode([
            "serviceID" => $serviceID, 
            "mobileNumber" => $phone           
        ]);
	    $url="https://inlomax.com/api/data";
    }
	
	$payLoad=[
	    "url" => $url,
	    "method" => $method,
	    "postFields" => $postFields,
	    "headers" => $headers
	 ];

	$response=curlRequest($payLoad); 
	$data=[];
	if($isGladTidings){
	    if(isset($response['Status'])){
	        $trxStatus=$response['Status'];
	        if($trxStatus == "successful"){
    	        $status="success";
    	        $message="Transaction was successful";
    	        $reference=$response['id'];
    	        $amount=$response['plan_amount'];
    	        $data['apiReference']=$reference;
    	        $data['amount']=$amount;
    	        $data['status']=$status;
    	    }
    	    else{
    	        $trxStatus="failed";
    	        $status="error";
    	        $message="Transaction Failed";
    	        $data['status']=$trxStatus;
    	    }
	    }
	    else{
	        $status="error";
	        $message=$response['error'];
	        $data['status']="failed";
	    }
	}
	else if($isNcWallet){
        if(isset($response['status'])){
	        $trxStatus=$response['status'];
            if($trxStatus == "success"){
    	        $status="success";
    	        $message="Transaction was successful";
    	        $reference=$response['request-id'];
    	        $amount=$response['amount'];
    	        $data['apiReference']=$reference;
    	        $data['amount']=$amount;
    	        $data['status']=$status;
    	    }
    	    else{
    	        $trxStatus="failed";
    	        $status="error";
    	        $message=$response['api_response'];
    	        $data['status']=$trxStatus;
    	    }
        }
        else{
	        $status="error";
	        $message="Something went wrong with transaction";
	        $data['status']="failed";
	    }
	}
	else if($isGwanyo){
        if(isset($response['status'])){
	        $trxStatus=$response['status'];
            if($trxStatus == "success"){
    	        $status="success";
    	        $message="Transaction was successful";
    	        $reference=$response['data']['clientReference'];
    	        $amount=$response['data']['amount'];
    	        $data['apiReference']=$reference;
    	        $data['amount']=$amount;
    	        $data['status']=$status;
    	    }
    	    else{
    	        $trxStatus="failed";
    	        $status="error";
    	        $message=$response['message'];
    	        $data['status']=$trxStatus;
    	    }
        }
        else{
	        $status="error";
	        $message="Something went wrong with transaction";
	        $data['status']="failed";
	    }
	}
	else if($isUzobest){
	    if(isset($response['status'])){
	        $trxStatus=$response['status'];
	        if($trxStatus == "successful"){
    	        $status="success";
    	        $message=$response['message'];
    	        $reference=$response['transaction_id'];
    	        $amount=$response['transaction_id'];
    	        $data['apiReference']=$reference;
    	        $data['amount']=$amount;
    	        $data['status']=$status;
    	    }
    	    else{
    	        $trxStatus="failed";
    	        $status="error";
    	        $message=$response['message'];
    	        $data['status']=$trxStatus;
    	    }
        }
        else{
	        $status="error";
	        $message="Something went wrong with transaction";
	        $data['status']="failed";
	    }
	}
	else if($isInlomax){
        if(isset($response['status'])){
	        $trxStatus=$response['status'];
            if($trxStatus == "success"){
    	        $status="success";
    	        $message=$response['message'];
    	        $reference=$response['data']['reference'];
    	        $amount=$response['data']['amount'];
    	        $data['apiReference']=$reference;
    	        $data['amount']=$amount;
    	        $data['status']=$status;
    	    }
    	    else{
    	        $trxStatus="failed";
    	        $status="error";
    	        $message=$response['message'];
    	        $data['status']=$trxStatus;
    	    }
        }
        else{
	        $status="error";
	        $message="Something went wrong with transaction";
	        $data['status']="failed";
	    }
	}

	$response=[
	    "status" => $status,
	    "message" => $message,
	    "data" => $data
	];
	
	return $response;
}


function validateCable($data) {
    global $uzobestApiKey;
	$cableID=$data['cableID'];
	$serviceID=$data['serviceID'];
	$iucNum=$data['iucNum'];
	$cable=$data['cable'];
	$method="GET";
	$url="https://uzobestgsm.ng/api/v1/validate_iuc?cablename=$cable&iuc=$iucNum";
	$postFields=[] ;
    $headers=[
	   "Authorization: $uzobestApiKey"
	];
	
	$payLoad=[
	    "url" => $url,
	    "method" => $method,
	    "postFields" => $postFields,
	    "headers" => $headers
	 ];

	$response=curlRequest($payLoad);
	$data=[];
	if(isset($response['status'])){
	    $status=$response['status'];
	    if($status == "successful"){
	        $status="success";
	        $message="Cable validated successfully";
	        $customerName=$response['info'];
	        $currentPlan=$response['status'];
	        $data['customerName']=$customerName;
	        $data['currentBouquet']=$currentPlan;
	    }
	    else{
	        $status="error";
	        $response['msg'];
	    }
	}
	else{
	    $status="error";
	    $message="Something went wrong validating cable";
	}
    $response=[
	    "status" => $status,
	    "message" => $message,
	    "data" => $data
	];
	
	return $response;
}

function subCable($data) {
    global $gladTidingsApiKey, $ncWalletApiKey, $uzobestApiKey, $inlomaxApiKey, $gwanyoApiKey;
    
	$cable=$data['cable'];
	$cableID=$data['cableID'];
	$serviceID=$data['serviceID'];
	$iucNum=$data['iucNum'];
	$reference=$data['reference'];
	$merchant=$data['merchant'];
	$type="subCable";

	$method="POST";
	$isGladTidings=$isNcWallet=$isUzobest=$isInlomax=$isGwanyo=false;
    if($merchant == "gladtidings"){
        $isGladTidings=true;
        $token=$gladTidingsApiKey;
        $headers=[
    	   "Authorization: Token $token",
    	];
        $postFields=[
            "cablename" => $cableID,  
            "smart_card_number" => $iucNum, 
            "cableplan" => $serviceID, 
        ];
	    $url="https://www.gladtidingsdata.com/api/cablesub/";
    }
    else if($merchant == "ncwallet"){
        $isNcWallet=true;
        $token=$ncWalletApiKey;
        $headers=[
    	   "Authorization: $token",
    	];
        $postFields=json_encode([
            "cable" => $cableID, 
            "iuc" => $iucNum, 
            "cable_plan" => $serviceID,
            "bypass" => true,
            "request-id" => $reference
        ]);
	    $url="https://ncwallet.ng/api/cable/";
    }
    else if($merchant == "gwanyo"){
        $isGwanyo=true;
        $token=$gwanyoApiKey;
        $headers=[
    	   "Authorization-Token: $token",
    	];
        $postFields=json_encode([
            "serviceID" => $serviceID, 
            "cableNum" => $iucNum,
            "clientReference" => $reference
        ]);
	    $url="https://gwanyoconnect.com.ng/api/cable.php";
    }
	else if($merchant == "uzobest"){
        $isUzobest=true;
        $token=$uzobestApiKey;
        $headers=[
    	   "Authorization: $uzobestApiKey",
    	];
        $postFields=[  
            "iuc" => $iucNum, 
            "cable_id" => $serviceID,
            "phone_number" => "08132007600" 
        ];
	    $url="https://uzobestgsm.ng/api/v1/purchase_cable";
    }
	else if($merchant == "inlomax"){
        $isInlomax=true;
        $token=$inlomaxApiKey;
        $headers=[
    	   "Authorization: Token $token",
    	];
        $postFields=json_encode([
            "serviceID" => $serviceID, 
            "iucNum" => $iucNum
        ]);
	    $url="https://inlomax.com/api/cable";
    }
	
	
	$payLoad=[
	    "url" => $url,
	    "method" => $method,
	    "postFields" => $postFields,
	    "headers" => $headers
	 ];
	 $response=curlRequest($payLoad) ;
	$data=[];
	if($isGladTidings){
	    if(isset($response['Status'])){
	        $trxStatus=$response['Status'];
	        if($trxStatus == "successful"){
    	        $status="success";
    	        $message="Transaction was successful";
    	        $reference=$response['id'];
    	        $amount=$response['plan_amount'];
    	        $data['apiReference']=$reference;
    	        $data['amount']=$amount;
    	        $data['status']=$status;
    	    }
    	    else{
    	       $trxStatus="failed";
    	        $status="error";
    	        $message="Transaction Failed";
    	        $data['status']=$trxStatus;
    	    }
	    }
	    else{
	        $status="error";
	        $message=$response['error'];
	        $data['status']="failed";
	    }
	}
	else if($isNcWallet){
        if(isset($response['status'])){
	        $trxStatus=$response['status'];
            if($trxStatus == "success"){
    	        $status="success";
    	        $message="Transaction was successful";
    	        $reference=$response['request-id'];
    	        $amount=$response['amount'];
    	        $data['apiReference']=$reference;
    	        $data['amount']=$amount;
    	        $data['status']=$status;
    	    }
    	    else{
    	        $trxStatus=$trxStatus=="fail" ? "failed" : $trxStatus; 
    	        $status="error";
    	        $message=$response['msg'];
    	        $data['status']=$trxStatus;
    	    }
        }
        else{
	        $status="error";
	        $message="Something went wrong with transaction";
	        $data['status']="failed";
	    }
	}
	else if($isGwanyo){
        if(isset($response['status'])){
	        $trxStatus=$response['status'];
            if($trxStatus == "success"){
    	        $status="success";
    	        $message="Transaction was successful";
    	        $reference=$response['data']['clientReference'];
    	        $amount=$response['data']['amount'];
    	        $data['apiReference']=$reference;
    	        $data['amount']=$amount;
    	        $data['status']=$status;
    	    }
    	    else{
    	        $trxStatus=$trxStatus=="error" ? "failed" : $trxStatus; 
    	        $status="error";
    	        $message=$response['message'] =json_encode($response) ;
    	        $data['status']=$trxStatus;
    	    }
        }
        else{
	        $status="error";
	        $message="Something went wrong with transaction";
	        $data['status']="failed";
	    }
	}
	else if($isUzobest){
        if(isset($response['status'])){
	        $trxStatus=$response['status'];
	        if($trxStatus == "successful"){
    	        $status="success";
    	        $message="Transaction was successful";
    	        $reference=$response['transaction_id'];
    	        $amount=$response['transaction_id'];
    	        $data['apiReference']=$reference;
    	        $data['amount']=$amount;
    	        $data['status']=$status;
    	    }
    	    else{
    	        $trxStatus=$trxStatus=="error" ? "failed" : $trxStatus; 
    	        $status="error";
    	        $message=$response['message'] =json_encode($response) ;
    	        $data['status']=$trxStatus;
    	    }
        }
        else{
	        $status="error";
	        $message="Something went wrong with transaction";
	        $data['status']="failed";
	    }
	}
	else if($isInlomax){
        if(isset($response['status'])){
	        $trxStatus=$response['status'];
            if($trxStatus == "success"){
    	        $status="success";
    	        $message="Transaction was successful";
    	        $reference=$response['data']['reference'];
    	        $amount=$response['data']['amount'];
    	        $data['apiReference']=$reference;
    	        $data['amount']=$amount;
    	        $data['status']=$status;
    	    }
    	    else{
    	        $trxStatus=$trxStatus=="error" ? "failed" : $trxStatus; 
    	        $status="error";
    	        $message=$response['message'] =json_encode($response) ;
    	        $data['status']=$trxStatus;
    	    }
        }
        else{
	        $status="error";
	        $message="Something went wrong with transaction";
	        $data['status']="failed";
	    }
	}
	
	$response=[
	    "status" => $status,
	    "message" => $message,
	    "data" => $data
	];
	
	return $response;
}

function validateElectric($data) {
    global $uzobestApiKey;
	$serviceID=$data['serviceID'];
	$meterNum=$data['meterNum'];
	$meterType=$data['meterType'];
	$amount=$data['amount'];
	$type="validateElectric";

	$method="GET";
	$url="https://uzobestgsm.ng/api/v1/validate_meter?meter_type=prepaid&disco_name=$serviceID&meter_number=$meterNum" ;
	$postFields=[] ;
    $headers=[
	   "Authorization: $uzobestApiKey",
	   "Content-Type: application/json"
	];
	
	$payLoad=[
	    "url" => $url,
	    "method" => $method,
	    "postFields" => $postFields,
	    "headers" => $headers
	 ];

	$response=curlRequest($payLoad);
	$data=["status" => "failed"];

	if(isset($response['status'])){
	    $status=$response['status'];
	    if($status == "successful"){
	        $status="success";
	        $message="Meter validated successfully";
	        $customerName=$response['info'];
	        $data['customerName']=$customerName;
	        $data['status']="success";
	    }
	    else{
	        $status="error";
	        $message=$response['msg'];
	    }
	}
	else{
	    $status="error";
	    $message="Something went wrong validating meter";
	}
    $response=[
	    "status" => $status,
	    "message" => $message,
	    "data" => $data
	];
	
	return $response;
}
function payElectric($data) {
    global $gladTidingsApiKey, $ncWalletApiKey, $uzobestApiKey, $inlomaxApiKey, $gwanyoApiKey;
    
	$serviceID=$data['serviceID'];
	$meterNum=$data['meterNum'];
	$meterType=$data['meterType'];
	$amount=$data['amount'];
	$reference=$data['reference']=json_encode($data) ;
	$merchant=$data['merchant'];
	$type="payElectric";

	$method="POST";
    $isGladTidings=$isNcWallet=$isUzobest=$isInlomax=$isGwanyo=false;
    if($merchant == "gladtidings"){
        $isGladTidings=true;
        $token=$gladTidingsApiKey;
        $headers=[
    	   "Authorization: Token $token",
    	];
        $postFields=[
            "disco_name" => $serviceID,  
            "meter_number" => $meterNum, 
            "MeterType" => $meterType, 
            "amount" => $amount
        ];
	    $url="https://www.gladtidingsdata.com/api/billpayment/";
    }
    else if($merchant == "ncwallet"){
        $isNcWallet=true;
        $token=$ncWalletApiKey;
        $headers=[
    	   "Authorization: $token",
    	];
        $postFields=json_encode([
            "meter_type" => $meterType, 
            "meter_number" => $meterNum, 
            "disco" => $serviceID,
            "amount" => $amount,
            "bypass" => true,
            "request-id" => $reference
        ]);
	    $url="https:/ncwallet.ng/api/bill/";
    }
	else if($merchant == "gwanyo"){
        $isGwanyo=true;
        $token=$gwanyoApiKey;
        $headers=[
    	   "Authorization-Token: $token",
    	];
        $postFields=json_encode([
            "serviceID" => $serviceID, 
            "meterNum" => $meterNum,
            "meterType" => $meterType,
            "amount" => $amount,
            "clientReference" => $reference
        ]);
	    $url="https://gwanyoconnect.com.ng/api/payelectric.php";
    }
	else if($merchant == "uzobest"){
        $isUzobest=true;
        $token=$uzobestApiKey;
        $headers=[
    	   "Authorization: $uzobestApiKey",
    	];
        $postFields=[
            "disco_name" => $serviceID,  
            "meter_number" => $meterNum, 
            "meter_type" => $meterType, 
            "amount" => $amount,
            "phone_number" => "08132007600"

        ];
	    $url="https://uzobestgsm.ng/api/v1/purchase_electricity";
    }
	else if($merchant == "inlomax"){
        $isInlomax=true;
        $token=$inlomaxApiKey;
        $headers=[
    	   "Authorization: Token $token",
    	];
        $postFields=json_encode([
            "serviceID" => $serviceID, 
            "meterNum" => $meterNum,
            "meterType" => $meterType,
            "amount" => $amount
        ]);
	    $url="https://inlomax.com/api/payelectric";
    }
	
	$payLoad=[
	    "url" => $url,
	    "method" => $method,
	    "postFields" => $postFields,
	    "headers" => $headers
	 ];

	$response=curlRequest($payLoad); 
	$data=[];
	if($isGladTidings){
	    if(isset($response['Status'])){
	        $trxStatus=$response['Status'];
	        if($trxStatus == "successful"){
    	        $status="success";
    	        $message="Transaction was successful";
    	        $reference=$response['id'];
    	        $amount=$response['plan_amount'];
    	        $data['apiReference']=$reference;
    	        $data['amount']=$amount;
    	        $data['status']=$status;
    	    }
    	    else{
    	       $trxStatus="failed";
    	        $status="error";
    	        $message="Transaction Failed";
    	        $data['status']=$trxStatus;
    	    }
	    }
	    else{
	        $status="error";
	        $message=$response['error'];
	        $data['status']="failed";
	    }
	}
	else if($isNcWallet){
        if(isset($response['status'])){
	        $trxStatus=$response['status'];
            if($trxStatus == "success"){
    	        $status="success";
    	        $message="Transaction was successful";
    	        $reference=$response['request-id'];
    	        $amount=$response['Amount'];
    	        $token=$response['token'];
    	        $customerAddress=$response['customerAddress'];
    	        $customerName=$response['customerName'];
    	        $units=$response['units'];
    	        $data['apiReference']=$reference;
    	        $data['amount']=$amount;
    	        $data['token']=$token;
    	        $data['customerAddress']=$customerAddress;
    	        $data['customerName']=$customerName;
    	        $data['status']=$status;
    	        $data['units']=$units;
    	    }
    	    else{
    	        $trxStatus=$trxStatus=="fail" ? "failed" : $trxStatus; 
    	        $status="error";
    	        $message=$response['msg'] =json_encode($response) ;
    	        $data['status']=$trxStatus;
    	    }
        }
        else{
	        $status="error";
	        $message="Something went wrong with transaction";
	        $data['status']="failed";
	    }
	}
	else if($isGwanyo){
        if(isset($response['status'])){
	        $trxStatus=$response['status'];
            if($trxStatus == "success"){
    	        $status="success";
    	        $message="Transaction was successful";
    	        $reference=$response['data']['clientReference'];
    	        $amount=$response['amount']['amount'];
    	        $token=$response['amount']['token'];
    	        $data['apiReference']=$reference;
    	        $data['amount']=$amount;
    	        $data['token']=$token;
    	        $data['customerAddress']="";
    	        $data['customerName']="";
    	        $data['status']=$status;
    	        $data['units']="";
    	    }
    	    else{
    	        $trxStatus=$trxStatus=="error" ? "failed" : "pending"; 
    	        $status="error";
    	        $message=$response['message'];
    	        $data['status']=$trxStatus;
    	    }
        }
        else{
	        $status="error";
	        $message="Something went wrong with transaction";
	        $data['status']="failed";
	    }
	}
	else if($isUzobest){
	    if(isset($response['status'])){
	        $trxStatus=$response['status'];
	        if($trxStatus == "successful"){
    	        $status="success";
    	        $message="Transaction was successful";
				$reference=$response['transaction_id'];
    	        $amount=$response['transaction_id'];
    	        $token=$response['token'];
    	        $customerAddress=$response['transaction_id'];
    	        $customerName=$response['transaction_id'];
    	        $units=$response['transaction_id'];
    	        $data['apiReference']=$reference;
    	        $data['amount']=$amount;
    	        $data['token']=$token;
    	        $data['customerAddress']=$customerAddress;
    	        $data['customerName']=$customerName;
    	        $data['status']=$status;
    	        $data['units']=$units;

				
			}
    	    else{
    	        $trxStatus=$trxStatus=="error" ? "failed" : "pending"; 
    	        $status="error";
    	        $message=$response['message'];
    	        $data['status']=$trxStatus;
    	    }
        }
        else{
	        $status="error";
	        $message="Something went wrong with transaction";
	        $data['status']="failed";
	    }
	}
	else if($isInlomax){
        if(isset($response['status'])){
	        $trxStatus=$response['status'];
            if($trxStatus == "success"){
    	        $status="success";
    	        $message="Transaction was successful";
    	        $reference=$response['data']['reference'];
    	        $amount=$response['data']['amount'];
    	        $token=$response['data']['token'];
    	        $data['apiReference']=$reference;
    	        $data['amount']=$amount;
    	        $data['token']=$token;
    	        $data['customerAddress']="";
    	        $data['customerName']="";
    	        $data['status']=$status;
    	        $data['units']="";
    	    }
    	    else{
    	        $trxStatus=$trxStatus=="error" ? "failed" : "pending"; 
    	        $status="error";
    	        $message=$response['message'];
    	        $data['status']=$trxStatus;
    	    }
        }
        else{
	        $status="error";
	        $message="Something went wrong with transaction";
	        $data['status']="failed";
	    }
	}

	$response=[
	    "status" => $status,
	    "message" => $message,
	    "data" => $data
	];
	
	return $response;
}

function educationalPin($data) {
    global $gladTidingsApiKey, $ncWalletApiKey, $uzobestApiKey, $inlomaxApiKey, $gwanyoApiKey;
    
	$serviceID=$data['serviceID'];
	$quantity=$data['quantity'];
	$reference=$data['reference'];
	$educationType=$data['educationType'];
	$merchant=$data['merchant'];

	$method="POST";
    $isGladTidings=$isNcWallet=$isUzobest=$isInlomax=$isGwanyo=false;
    if($merchant == "gladtidings"){
        $isGladTidings=true;
        $token=$gladTidingsApiKey;
        $headers=[
    	   "Authorization: Token $token",
    	];
        $postFields=[
            "exam_name" => $educationType,  
            "quantity" => $quantity, 
        ];
	    $url="https://www.gladtidingsdata.com/api/epin/";
    }
    else if($merchant == "ncwallet"){
        $isNcWallet=true;
        $token=$ncWalletApiKey;
        $headers=[
    	   "Authorization: $token",
    	];
        $postFields=json_encode([
            "exam" => $serviceID,
            "quantity" => $quantity
        ]);
	    $url="https://ncwallet.ng/api/exam/";
    }
	else if($merchant == "gwanyo"){
        $isGwanyo=true;
        $token=$gwanyoApiKey;
        $headers=[
    	   "Authorization-Token: $token",
    	];
        $postFields=json_encode([
            "serviceID" => $serviceID, 
            "quantity" => $quantity,
            "clientReference" => $reference
        ]);
	    $url="https://gwanyoconnect.com.ng/api/education.php";
    }
	else if($merchant == "uzobest"){
        $isUzobest=true;
        $token=$uzobestApiKey;
        $headers=[
    	   "Authorization: $uzobestApiKey",
    	];
        $postFields=[
            "exam_id" => $educationType,  
            "quantity" => $quantity, 
        ];
	    $url="https://uzobestgsm.ng/api/v1/purchase_pin";
    }
	else if($merchant == "inlomax"){
        $isInlomax=true;
        $token=$inlomaxApiKey;
        $headers=[
    	   "Authorization: Token $token",
    	];
        $postFields=json_encode([
            "serviceID" => $serviceID, 
            "quantity" => $quantity
        ]);
	    $url="https//inlomax.com/api/education";
    }

	$payLoad=[
	    "url" => $url,
	    "method" => $method,
	    "postFields" => $postFields,
	    "headers" => $headers
	 ];

	$response=curlRequest($payLoad); 
    
	$data=[];
	if($isGladTidings){
	    if(isset($response['Status'])){
	        $trxStatus=$response['Status'];
	        if($trxStatus == "successful"){
    	        $status="success";
    	        $message="Transaction was successful";
    	        $reference=$response['id'];
    	        $amount=$response['plan_amount'];
    	        $data['apiReference']=$reference;
    	        $data['amount']=$amount;
    	        $data['status']=$status;
    	    }
    	    else{
    	        $trxStatus="failed";
    	        $status="error";
    	        $message="Transaction Failed";
    	        $data['status']=$trxStatus;
    	    }
	    }
	    else{
	        $status="error";
	        $message=$response['error'];
	        $data['status']="failed";
	    }
	}
	else if($isNcWallet){
        if(isset($response['status'])){
	        $trxStatus=$response['status'];
            if($trxStatus == "success"){
    	        $status="success";
    	        $message="Transaction was successful";
    	        $pin=$response['pin'];
    	        $pins=[];
                $pinSerial=explode("||", $pin);
                $pinsX=$pinSerial[0];
                $pinsY=explode(",", explode("=>", $pinsX)[1]);
                $serialNoX=$pinSerial[1];
                $serialNoY=explode(",", explode("=>", $serialNoX)[1]);
                
                for($i = 0; $i < $quantity; $i++){
                    $pins[$i]['pin']=$pinsY[$i];
                    $pins[$i]['serialNo']=$serialNoY[$i];
                }

    	        $data['apiReference']=$reference;
    	        $data['pins']=$pins;
    	        $data['status']=$status;
    	    }
    	    else{
    	        $trxStatus=$trxStatus=="fail" ? "failed" : $trxStatus; 
    	        $status="error";
    	        $message=$response['msg']=json_encode($response);
    	        $data['status']=$trxStatus;
    	    }
        }
        else{
	        $status="error";
	        $message="Something went wrong with transaction";
	        $data['status']="failed";
	    }
	}
	else if($isGwanyo){
        if(isset($response['status'])){
	        $trxStatus=$response['status'];
            if($trxStatus == "success"){
    	        $status="success";
    	        $message="Transaction was successful";
    	        $pins=$response['data']['pins'];
    	        $reference=$response['data']['clientReference'];
    	       

    	        $data['apiReference']=$reference;
    	        $data['pins']=$pins;
    	        $data['status']=$status;
    	    }
    	    else{
    	        $trxStatus=$trxStatus=="error" ? "failed" : $trxStatus; 
    	        $status="error";
    	        $message=$response['message'];
    	        $data['status']=$trxStatus;
    	    }
        }
        else{
	        $status="error";
	        $message="Something went wrong with transaction";
	        $data['status']="failed";
	    }
	}
	else if($isUzobest){
		if(isset($response['status'])){
			$trxStatus=$response['status'];
			if($trxStatus == "successful"){
				$status="success";
				$message="Transaction was successful";
				$reference=$response['transaction_id'];
				$amount=$response['transaction_id'];
				$data['apiReference']=$reference;
				$data['amount']=$amount;
				$data['status']=$status;
			}
			else{
				$trxStatus=$trxStatus=="error" ? "failed" : $trxStatus; 
    	        $status="error";
    	        $message=$response['message'];
    	        $data['status']=$trxStatus;
    	    }
        }
        else{
	        $status="error";
	        $message="Something went wrong with transaction";
	        $data['status']="failed";
		}
	}
	else if($isInlomax){
        if(isset($response['status'])){
	        $trxStatus=$response['status'];
            if($trxStatus == "success"){
    	        $status="success";
    	        $message="Transaction was successful";
    	        $pins=$response['data']['pins'][0]['pin'];
    	        $reference=$response['data']['reference'];
    	       

    	        $data['apiReference']=$reference;
    	        $data['pins']=$pins;
    	        $data['status']=$status;
    	    }
    	    else{
    	        $trxStatus=$trxStatus=="error" ? "failed" : $trxStatus; 
    	        $status="error";
    	        $message=$response['message'];
    	        $data['status']=$trxStatus;
    	    }
        }
        else{
	        $status="error";
	        $message="Something went wrong with transaction";
	        $data['status']="failed";
	    }
	}

	$response=[
	    "status" => $status,
	    "message" => $message,
	    "data" => $data
	];
	
	return $response;
}


function buyDataCard($data) {
    global $gladTidingsApiKey, $ncWalletApiKey, $uzobestApiKey, $inlomaxApiKey, $gwanyoApiKey, $username;
    
	$serviceID=$data['serviceID'];
	$networkID=$data['networkID'];
	$reference=$data['reference'];
	$merchant=$data['merchant'];
	$quantity=$data['quantity'];

	$method="POST";
    $isGladTidings=$isNcWallet=$isUzobest=$isInlomax=$isGwanyo=false;
    if($merchant == "gladtidings"){
        $isGladTidings=true;
        $token=$gladTidingsApiKey;
        $headers=[
    	   "Authorization: Token $token",
    	];
         $postFields=[
            "plan" => $serviceID,  
            "quantity" => $quantity, 
            "name_on_card" => $username
        ];
	    $url="https://www.gladtidingsdata.com/api/data-card/";
    }
    else if($merchant == "ncwallet"){
        $isNcWallet=true;
        $token=$ncWalletApiKey;
        $headers=[
    	   "Authorization: $token",
    	];
        $postFields=json_encode([
            "network" => $networkID,
            "card_name" => $username,
            "plan_type" => $serviceID,
            "quantity" => $quantity
        ]);
	    $url="https://ncwallet.ng/api/data_card/";
    }
	else if($merchant == "inlomax"){
        $isInlomax=true;
        $token=$inlomaxApiKey;
        $headers=[
    	   "Authorization: Token $token",
    	];
        $postFields=json_encode([
            "serviceID" => $serviceID,
            "quantity" => $quantity
        ]);
	    $url="https://inlomax.com/api/datacard";
    }
	
	$payLoad=[
	    "url" => $url,
	    "method" => $method,
	    "postFields" => $postFields,
	    "headers" => $headers
	 ];

	$response=curlRequest($payLoad); 

	$data=[];
if($isGladTidings){
	    if(isset($response['Status'])){
	        $trxStatus=$response['Status'];
	        if($trxStatus == "successful"){
    	        $status="success";
    	        $message="Transaction was successful";
    	        $reference=$response['id'];
    	       $pin=$response['datacard_pins'][0]['fields']['pin'];
    	        $serial=$response['datacard_pins'][0]['fields']['serial'];
    	        $loadPin=$response['datacard_pins'][0]['fields']['dail_by'];
    	        $pins=[];
                $pinsX=explode(",", $pin);
                $serialX=explode(",", $serial);
                
                for($i = 0; $i < $quantity; $i++){
                    $pins[$i]['pin']=$pinsX[$i];
                    $pins[$i]['serialNo']=$serialX[$i];
                }

    	        $data['apiReference']=$reference;
    	        $data['pins']=$pins;
    	        $data['loadPin']=$loadPin;
    	        $data['status']=$status;
    	    }
    	    else{
    	        $trxStatus="failed";
    	        $status="error";
    	        $message="Transaction failed";
    	        $data['status']=$trxStatus;
    	    }
	    }
	    else{
	        $status="error";
	        $message=$response['error'];
	        $data['status']="failed";
	    }
	}
	else if($isNcWallet){
        if(isset($response['status'])){
	        $trxStatus=$response['status'];
            if($trxStatus == "success"){
    	        $status="success";
    	        $message="Transaction was successful";
    	        $pin=$response['pin'];
    	        $serial=$response['serial'];
    	        $loadPin=$response['load_pin'];
    	        $pins=[];
                $pinsX=explode(",", $pin);
                $serialX=explode(",", $serial);
                
                for($i = 0; $i < $quantity; $i++){
                    $pins[$i]['pin']=$pinsX[$i];
                    $pins[$i]['serialNo']=$serialX[$i];
                }

    	        $data['apiReference']=$reference;
    	        $data['pins']=$pins;
    	        $data['loadPin']=$loadPin;
    	        $data['status']=$status;
    	    }
    	    else{
    	        $trxStatus=$trxStatus=="fail" ? "failed" : $trxStatus; 
    	        $status="error";
    	        $message=$response['msg'];
    	        $data['status']=$trxStatus;
    	    }
        }
        else{
	        $status="error";
	        $message="Something went wrong with transaction";
	        $data['status']="failed";
	    }
	}
	else if($isInlomax){
        if(isset($response['status'])){
	        $trxStatus=$response['status'];
            if($trxStatus == "success"){
    	        $status="success";
    	        $message="Transaction was successful";
    	        $pin=$response['data']['pins'][0]['pin'];
    	        $serial=$response['data']['pins'][0]['serialNo'];
    	        $loadPin=$response['data']['load_pin'];
    	        $pins=[];
                $pinsX=explode(",", $pin);
                $serialX=explode(",", $serial);
                
                for($i = 0; $i < $quantity; $i++){
                    $pins[$i]['pin']=$pinsX[$i];
                    $pins[$i]['serialNo']=$serialX[$i];
                }

    	        $data['apiReference']=$reference;
    	        $data['pins']=$pins;
    	        $data['loadPin']=$loadPin;
    	        $data['status']=$status;
    	    }
    	    else{
    	        $trxStatus=$trxStatus=="fail" ? "failed" : $trxStatus; 
    	        $status="error";
    	        $message=$response['msg'];
    	        $data['status']=$trxStatus;
    	    }
        }
        else{
	        $status="error";
	        $message="Something went wrong with transaction";
	        $data['status']="failed";
	    }
	}
	
	$response=[
	    "status" => $status,
	    "message" => $message,
	    "data" => $data
	];
	

	return $response;
}


function buyAirtimePin($data) {
    global $gladTidingsApiKey, $ncWalletApiKey, $uzobestApiKey, $inlomaxApiKey, $gwanyoApiKey, $username;
    
	$serviceID=$data['serviceID'];
	$reference=$data['reference'];
	$merchant=$data['merchant'];
	$quantity=$data['quantity'];
	$amount=$data['amount'];

	$method="POST";
    $isGladTidings=$isNcWallet=$isUzobest=$isInlomax=$isGwanyo=false;
    if($merchant == "gladtidings"){
        $isGladTidings=true;
        $token=$gladTidingsApiKey;
        $headers=[
    	   "Authorization: Token $token",
    	];
        $postFields=[
            "network" => $networkid,
            "network_amount" => $serviceID,
            "quantity" => $quantity, 
            "name_on_card" => $username
        ];
	    $url="https://www.gladtidingsdata.com/api/rechargepin/";
    }
    else if($merchant == "ncwallet"){
        $isNcWallet=true;
        $token=$ncWalletApiKey;
        $headers=[
    	   "Authorization: $token",
    		"Content-Type:application/json" 
    	];
        $postFields=json_encode([
            "amount" => $amount,
            "name_on_card" => $username,
            "network" => $serviceID,
            "quantity" => $quantity
        ]);
	    $url="https://ncwallet.ng/api/recharge/";
    }
	else if($merchant == "inlomax"){
        $isInlomax=true;
        $token=$inlomaxApiKey;
        $headers=[
    	   "Authorization: Token $token",
    		"Content-Type:application/json" 
    	];
        $postFields=json_encode([
            "amount" => $amount,
            "serviceID" => $serviceID,
            "quantity" => $quantity
        ]);
	    $url="https://inlomax.com/api/airtimepin";
    }
	
	$payLoad=[
	    "url" => $url,
	    "method" => $method,
	    "postFields" => $postFields,
	    "headers" => $headers
	 ];

	$response=curlRequest($payLoad); 

	$data=[];
	if($isGladTidings){
	    if(isset($response['Status'])){
	        $trxStatus=$response['Status'];
	        if($trxStatus == "successful"){
    	        $status="success";
    	        $message="Transaction was successful";
    	        $reference=$response['id'];
    	        $pin=$response['data_pin'][0]['fields']['pin'];
    	        $serial=$response['data_pin'][0]['fields']['serial'];
    	        $loadPin=$response['data_pin'][0]['fields']['load_code'];
    	        $pins=[];
                $pinsX=explode(",", $pin);
                $serialX=explode(",", $serial);
                
                for($i = 0; $i < $quantity; $i++){
                    $pins[$i]['pin']=$pinsX[$i];
                    $pins[$i]['serialNo']=$serialX[$i];
                }

    	        $data['apiReference']=$reference;
    	        $data['pins']=$pins;
    	        $data['loadPin']=$loadPin;
    	        $data['status']=$status;
    	    }
    	    else{
    	        $trxStatus="failed";
    	        $status="error";
    	        $message="Transaction failed";
    	        $data['status']=$trxStatus;
    	    }
	    }
	    else{
	        $status="error";
	        $message=$response['error'];
	        $data['status']="failed";
	    }
	}
	else if($isNcWallet){
        if(isset($response['status'])){
	        $trxStatus=$response['status'];
            if($trxStatus == "success"){
    	        $status="success";
    	        $message="Transaction was successful";
    	        $pin=$response['pin'];
    	        $serial=$response['serial'];
    	        $loadPin=$response['load_pin'];
    	        $pins=[];
                $pinsX=explode(",", $pin);
                $serialX=explode(",", $serial);
                
                for($i = 0; $i < $quantity; $i++){
                    $pins[$i]['pin']=$pinsX[$i];
                    $pins[$i]['serialNo']=$serialX[$i];
                }

    	        $data['apiReference']=$reference;
    	        $data['pins']=$pins;
    	        $data['loadPin']=$loadPin;
    	        $data['status']=$status;
    	    }
    	    else{
    	        $trxStatus=$trxStatus=="fail" ? "failed" : $trxStatus; 
    	        $status="error";
    	        $message=isset($response['msg']) ? $response['msg'] : "Airtime pin purchase failed";
    	        $data['status']=$trxStatus;
    	    }
        }
        else{
	        $status="error";
	        $message="Something went wrong with transaction";
	        $data['status']="failed";
	    }
	}
	else if($isInlomax){
        if(isset($response['status'])){
	        $trxStatus=$response['status'];
            if($trxStatus == "success"){
    	        $status="success";
    	        $message="Transaction was successful";
    	        $pin=$response['data']['pins'][0]['pin'];
    	        $serial=$response['data']['pins'][0]['serialNo'];
    	        $loadPin=$response['data']['loadPin'];
    	        $pins=[];
                $pinsX=explode(",", $pin);
                $serialX=explode(",", $serial);
                
                for($i = 0; $i < $quantity; $i++){
                    $pins[$i]['pin']=$pinsX[$i];
                    $pins[$i]['serialNo']=$serialX[$i];
                }

    	        $data['apiReference']=$reference;
    	        $data['pins']=$pins;
    	        $data['loadPin']=$loadPin;
    	        $data['status']=$status;
    	    }
    	    else{
    	        $trxStatus=$trxStatus=="fail" ? "failed" : $trxStatus; 
    	        $status="error";
    	        $message=isset($response['msg']) ? $response['msg'] : "Airtime pin purchase failed";
    	        $data['status']=$trxStatus;
    	    }
        }
        else{
	        $status="error";
	        $message="Something went wrong with transaction";
	        $data['status']="failed";
	    }
	}
	
	$response=[
	    "status" => $status,
	    "message" => $message,
	    "data" => $data
	];
	

	return $response;
}


function bulkSms($data) {
    global $gladTidingsApiKey, $ncWalletApiKey;
    
	$sender=$data['sender'];
	$message=$data['message'];
	$numbers=$data['numbers'];
	$merchant=$data['merchant'];
	$smsType=$data['smsType'];

	$method="POST";
    $isGladTidings=$isNcWallet=false;
    if($merchant == "gladtidings"){
        $isGladTidings=true;
        $token=$gladTidingsApiKey;
        $headers=[
    	   "Authorization: Token $token",
    	];
        $postFields=[
            "plan" => $serviceID,  
            "quantity" => $quantity, 
            "name_on_card" => "datacard"
        ];
	    $url="https://www.gladtidingsdata.com/api/data-card/";
    }
    else if($merchant == "ncwallet"){
        $isNcWallet=true;
        $token=$ncWalletApiKey;
        $headers=[
    	   "Authorization: $token",
    	];
        $postFields=json_encode([
            "sender" => $sender,
            "message" => $message,
            "number" => $numbers,
            "sms_type" => $smsType
        ]);
	    $url="https://ncwallet.ng/api/bulksms/";
    }
	
	
	$payLoad=[
	    "url" => $url,
	    "method" => $method,
	    "postFields" => $postFields,
	    "headers" => $headers
	 ];

	$response=curlRequest($payLoad); 
        // $response=json_decode('
        // {
        // "status" : "success",
        // "amount" : "3.5",
        // "correct_number" : "09090909090 09090909093",
        // "total_correct_number" : "09090909090 09090909093",
        // "total_wrong_number" : "0"
        // }', true);
    
    
	$data=[];
	if($isGladTidings){
	    if(isset($response['Status'])){
	        $trxStatus=$response['Status'];
	        if($trxStatus == "successful"){
    	        $status="success";
    	        $message="Transaction was successful";
    	        $reference=$response['id'];
    	        $amount=$response['plan_amount'];
    	        $data['apiReference']=$reference;
    	        $data['amount']=$amount;
    	        $data['status']=$status;
    	    }
    	    else{
    	        $trxStatus="pending";
    	        $status="error";
    	        $message="Transaction processing";
    	        $data['status']=$trxStatus;
    	    }
	    }
	    else{
	        $status="error";
	        $message=$response['error'];
	        $data['status']="failed";
	    }
	}
	else if($isNcWallet){
        if(isset($response['status'])){
	        $trxStatus=$response['status'];
            if($trxStatus == "success"){
    	        $status="success";
    	        $message="Transaction was successful";
    	        $totalCorrectNumber=$response['total_correct_number'];
    	        $totalWrongNumber=$response['total_wrong_number'];
    	        $data['totalWrongNumber']=$totalWrongNumber;
    	        $data['totalCorrectNumber']=$totalCorrectNumber;
    	        $data['status']=$status;
    	    }
    	    else{
    	        $trxStatus=$trxStatus=="fail" ? "failed" : $trxStatus; 
    	        $status="error";
    	        $message=$response['msg']=json_encode($response) ;
    	        $data['status']=$trxStatus;
    	    }
        }
        else{
	        $status="error";
	        $message="Something went wrong with transaction";
	        $data['status']="failed";
	    }
	}
	
	$response=[
	    "status" => $status,
	    "message" => $message,
	    "data" => $data
	];
	

	return $response;
}
?>